#ifndef TML_SDK_H
#define TML_SDK_H

/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

enum AbnormalGait
#ifdef __cplusplus
  : uint8_t
#endif // __cplusplus
 {
  /**
   * Default value per Protobuf convention
   */
  ABNORMAL_GAIT_UNSPECIFIED = 0,
  /**
   * No load detected
   */
  ABNORMAL_GAIT_NO_LOAD = 1,
  /**
   * Support phase detected
   */
  ABNORMAL_GAIT_HANDRAIL_SUPPORTED = 2,
  /**
   * Unilateral dragging detected
   */
  ABNORMAL_GAIT_UNILATERAL_DRAGGING = 3,
};
#ifndef __cplusplus
typedef uint8_t AbnormalGait;
#endif // __cplusplus

enum GaitPattern
#ifdef __cplusplus
  : uint8_t
#endif // __cplusplus
 {
  GAIT_PATTERN_UNSPECIFIED = 0,
  GAIT_PATTERN_WALK = 1,
  GAIT_PATTERN_RUN = 2,
};
#ifndef __cplusplus
typedef uint8_t GaitPattern;
#endif // __cplusplus

enum LogLevel
#ifdef __cplusplus
  : uint8_t
#endif // __cplusplus
 {
  LOG_LEVEL_ERROR = 0,
  LOG_LEVEL_WARN = 1,
  LOG_LEVEL_INFO = 2,
  LOG_LEVEL_DEBUG = 3,
  LOG_LEVEL_TRACE = 4,
};
#ifndef __cplusplus
typedef uint8_t LogLevel;
#endif // __cplusplus

typedef void (*GaitDataCallback)(uint32_t timmstamp,
                                 bool left_foot,
                                 uint32_t pattern,
                                 uint32_t gait_duration);

typedef void (*AbnormalEventCallback)(uint32_t timmstamp, uint32_t event_type);

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

/**
 * 初始化日志记录功能
 *
 * # 参数
 * - `level`: 日志级别
 */
void initialize_logging(LogLevel level);

/**
 * Sets the callback for GaitAnalysisResult data.
 *
 * # Arguments
 * * `callback` - The function to call when receiving GaitAnalysisResult data.
 */
void set_gait_data_callback(GaitDataCallback cb);

/**
 * Sets the callback for AbnormalEvent data.
 *
 * # Arguments
 * * `callback` - The function to call when receiving AbnormalEvent data.
 */
void set_abnormal_event_callback(AbnormalEventCallback cb);

/**
 * Receives a pointer to data and its length from C.
 * The data is borrowed and not freed by this function.
 * The caller is responsible for managing the memory.
 */
void did_receive_data(const uint8_t *data, uintptr_t len);

#ifdef __cplusplus
}  // extern "C"
#endif  // __cplusplus

#endif  /* TML_SDK_H */
