use crate::generated::edu_proto::*;
impl serde::Serialize for AccConfResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if self.config.is_some() {
      len += 1;
    }
    if self.acc_coefficient != 0. {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AccConfResp", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if let Some(v) = self.config.as_ref() {
      struct_ser.serialize_field("config", v)?;
    }
    if self.acc_coefficient != 0. {
      struct_ser.serialize_field("accCoefficient", &self.acc_coefficient)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AccConfResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "error",
      "port",
      "config",
      "acc_coefficient",
      "accCoefficient",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      Port,
      Config,
      AccCoefficient,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "port" => Ok(GeneratedField::Port),
              "config" => Ok(GeneratedField::Config),
              "accCoefficient" | "acc_coefficient" => Ok(GeneratedField::AccCoefficient),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AccConfResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AccConfResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AccConfResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut port__ = None;
        let mut config__ = None;
        let mut acc_coefficient__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::Config => {
              if config__.is_some() {
                return Err(serde::de::Error::duplicate_field("config"));
              }
              config__ = map_.next_value()?;
            }
            GeneratedField::AccCoefficient => {
              if acc_coefficient__.is_some() {
                return Err(serde::de::Error::duplicate_field("accCoefficient"));
              }
              acc_coefficient__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(AccConfResp {
          error: error__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          config: config__,
          acc_coefficient: acc_coefficient__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AccConfResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AccConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.acc_sr != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if self.data_type != 0 {
      len += 1;
    }
    if self.imu_calibration.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AccConfig", len)?;
    if self.acc_sr != 0 {
      let v = SamplingRate::try_from(self.acc_sr)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.acc_sr)))?;
      struct_ser.serialize_field("accSr", &v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if self.data_type != 0 {
      let v = UploadDataType::try_from(self.data_type)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.data_type)))?;
      struct_ser.serialize_field("dataType", &v)?;
    }
    if let Some(v) = self.imu_calibration.as_ref() {
      struct_ser.serialize_field("imuCalibration", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AccConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "acc_sr",
      "accSr",
      "port",
      "data_type",
      "dataType",
      "imu_calibration",
      "imuCalibration",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      AccSr,
      Port,
      DataType,
      ImuCalibration,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "accSr" | "acc_sr" => Ok(GeneratedField::AccSr),
              "port" => Ok(GeneratedField::Port),
              "dataType" | "data_type" => Ok(GeneratedField::DataType),
              "imuCalibration" | "imu_calibration" => Ok(GeneratedField::ImuCalibration),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AccConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AccConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AccConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut acc_sr__ = None;
        let mut port__ = None;
        let mut data_type__ = None;
        let mut imu_calibration__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::AccSr => {
              if acc_sr__.is_some() {
                return Err(serde::de::Error::duplicate_field("accSr"));
              }
              acc_sr__ = Some(map_.next_value::<SamplingRate>()? as i32);
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::DataType => {
              if data_type__.is_some() {
                return Err(serde::de::Error::duplicate_field("dataType"));
              }
              data_type__ = Some(map_.next_value::<UploadDataType>()? as i32);
            }
            GeneratedField::ImuCalibration => {
              if imu_calibration__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuCalibration"));
              }
              imu_calibration__ = map_.next_value()?;
            }
          }
        }
        Ok(AccConfig {
          acc_sr: acc_sr__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          data_type: data_type__.unwrap_or_default(),
          imu_calibration: imu_calibration__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AccConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AccData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.seq_num != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if !self.acc_raw_data.is_empty() {
      len += 1;
    }
    if !self.acc_correction_data.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AccData", len)?;
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if !self.acc_raw_data.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "accRawData",
        pbjson::private::base64::encode(&self.acc_raw_data).as_str(),
      )?;
    }
    if !self.acc_correction_data.is_empty() {
      struct_ser.serialize_field("accCorrectionData", &self.acc_correction_data)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AccData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "seq_num",
      "seqNum",
      "port",
      "acc_raw_data",
      "accRawData",
      "acc_correction_data",
      "accCorrectionData",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SeqNum,
      Port,
      AccRawData,
      AccCorrectionData,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "port" => Ok(GeneratedField::Port),
              "accRawData" | "acc_raw_data" => Ok(GeneratedField::AccRawData),
              "accCorrectionData" | "acc_correction_data" => Ok(GeneratedField::AccCorrectionData),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AccData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AccData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AccData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut seq_num__ = None;
        let mut port__ = None;
        let mut acc_raw_data__ = None;
        let mut acc_correction_data__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::AccRawData => {
              if acc_raw_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accRawData"));
              }
              acc_raw_data__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::AccCorrectionData => {
              if acc_correction_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accCorrectionData"));
              }
              acc_correction_data__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::NumberDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
          }
        }
        Ok(AccData {
          seq_num: seq_num__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          acc_raw_data: acc_raw_data__.unwrap_or_default(),
          acc_correction_data: acc_correction_data__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AccData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AfeConfResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.channel_subscriptions != 0 {
      len += 1;
    }
    if self.config.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AfeConfResp", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if self.channel_subscriptions != 0 {
      struct_ser.serialize_field("channelSubscriptions", &self.channel_subscriptions)?;
    }
    if let Some(v) = self.config.as_ref() {
      struct_ser.serialize_field("config", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AfeConfResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "error",
      "channel_subscriptions",
      "channelSubscriptions",
      "config",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      ChannelSubscriptions,
      Config,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "channelSubscriptions" | "channel_subscriptions" => {
                Ok(GeneratedField::ChannelSubscriptions)
              }
              "config" => Ok(GeneratedField::Config),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AfeConfResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AfeConfResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AfeConfResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut channel_subscriptions__ = None;
        let mut config__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::ChannelSubscriptions => {
              if channel_subscriptions__.is_some() {
                return Err(serde::de::Error::duplicate_field("channelSubscriptions"));
              }
              channel_subscriptions__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Config => {
              if config__.is_some() {
                return Err(serde::de::Error::duplicate_field("config"));
              }
              config__ = map_.next_value()?;
            }
          }
        }
        Ok(AfeConfResp {
          error: error__.unwrap_or_default(),
          channel_subscriptions: channel_subscriptions__.unwrap_or_default(),
          config: config__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AfeConfResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AfeConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.sample_rate != 0 {
      len += 1;
    }
    if self.channel_bits != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AfeConfig", len)?;
    if self.sample_rate != 0 {
      let v = AfeSampleRate::try_from(self.sample_rate)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.sample_rate)))?;
      struct_ser.serialize_field("sampleRate", &v)?;
    }
    if self.channel_bits != 0 {
      struct_ser.serialize_field("channelBits", &self.channel_bits)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AfeConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["sample_rate", "sampleRate", "channel_bits", "channelBits"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SampleRate,
      ChannelBits,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "sampleRate" | "sample_rate" => Ok(GeneratedField::SampleRate),
              "channelBits" | "channel_bits" => Ok(GeneratedField::ChannelBits),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AfeConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AfeConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AfeConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut sample_rate__ = None;
        let mut channel_bits__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SampleRate => {
              if sample_rate__.is_some() {
                return Err(serde::de::Error::duplicate_field("sampleRate"));
              }
              sample_rate__ = Some(map_.next_value::<AfeSampleRate>()? as i32);
            }
            GeneratedField::ChannelBits => {
              if channel_bits__.is_some() {
                return Err(serde::de::Error::duplicate_field("channelBits"));
              }
              channel_bits__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(AfeConfig {
          sample_rate: sample_rate__.unwrap_or_default(),
          channel_bits: channel_bits__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AfeConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AfeData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.seq_num != 0 {
      len += 1;
    }
    if self.lead_off_bits != 0 {
      len += 1;
    }
    if !self.channel_adc_value.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AfeData", len)?;
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if self.lead_off_bits != 0 {
      struct_ser.serialize_field("leadOffBits", &self.lead_off_bits)?;
    }
    if !self.channel_adc_value.is_empty() {
      struct_ser.serialize_field(
        "channelAdcValue",
        &self
          .channel_adc_value
          .iter()
          .map(pbjson::private::base64::encode)
          .collect::<Vec<_>>(),
      )?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AfeData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "seq_num",
      "seqNum",
      "lead_off_bits",
      "leadOffBits",
      "channel_adc_value",
      "channelAdcValue",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SeqNum,
      LeadOffBits,
      ChannelAdcValue,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "leadOffBits" | "lead_off_bits" => Ok(GeneratedField::LeadOffBits),
              "channelAdcValue" | "channel_adc_value" => Ok(GeneratedField::ChannelAdcValue),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AfeData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AfeData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AfeData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut seq_num__ = None;
        let mut lead_off_bits__ = None;
        let mut channel_adc_value__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::LeadOffBits => {
              if lead_off_bits__.is_some() {
                return Err(serde::de::Error::duplicate_field("leadOffBits"));
              }
              lead_off_bits__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::ChannelAdcValue => {
              if channel_adc_value__.is_some() {
                return Err(serde::de::Error::duplicate_field("channelAdcValue"));
              }
              channel_adc_value__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::BytesDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
          }
        }
        Ok(AfeData {
          seq_num: seq_num__.unwrap_or_default(),
          lead_off_bits: lead_off_bits__.unwrap_or_default(),
          channel_adc_value: channel_adc_value__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AfeData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AfeSampleRate {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::AfeSrInvalid => "AFE_SR_INVALID",
      Self::AfeSrOff => "AFE_SR_OFF",
      Self::AfeSr125 => "AFE_SR_125",
      Self::AfeSr250 => "AFE_SR_250",
      Self::AfeSr500 => "AFE_SR_500",
      Self::AfeSr1000 => "AFE_SR_1000",
      Self::AfeSr2000 => "AFE_SR_2000",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for AfeSampleRate {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "AFE_SR_INVALID",
      "AFE_SR_OFF",
      "AFE_SR_125",
      "AFE_SR_250",
      "AFE_SR_500",
      "AFE_SR_1000",
      "AFE_SR_2000",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AfeSampleRate;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "AFE_SR_INVALID" => Ok(AfeSampleRate::AfeSrInvalid),
          "AFE_SR_OFF" => Ok(AfeSampleRate::AfeSrOff),
          "AFE_SR_125" => Ok(AfeSampleRate::AfeSr125),
          "AFE_SR_250" => Ok(AfeSampleRate::AfeSr250),
          "AFE_SR_500" => Ok(AfeSampleRate::AfeSr500),
          "AFE_SR_1000" => Ok(AfeSampleRate::AfeSr1000),
          "AFE_SR_2000" => Ok(AfeSampleRate::AfeSr2000),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for AppDongle {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.msg_type != 0 {
      len += 1;
    }
    if self.device_info.is_some() {
      len += 1;
    }
    if self.setup_info.is_some() {
      len += 1;
    }
    if self.ota_cfg.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AppDongle", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if self.msg_type != 0 {
      let v = app_dongle::MsgType::try_from(self.msg_type)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.msg_type)))?;
      struct_ser.serialize_field("msgType", &v)?;
    }
    if let Some(v) = self.device_info.as_ref() {
      struct_ser.serialize_field("deviceInfo", v)?;
    }
    if let Some(v) = self.setup_info.as_ref() {
      struct_ser.serialize_field("setupInfo", v)?;
    }
    if let Some(v) = self.ota_cfg.as_ref() {
      struct_ser.serialize_field("otaCfg", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AppDongle {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "msg_type",
      "msgType",
      "device_info",
      "deviceInfo",
      "setup_info",
      "setupInfo",
      "ota_cfg",
      "otaCfg",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      MsgType,
      DeviceInfo,
      SetupInfo,
      OtaCfg,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "msgType" | "msg_type" => Ok(GeneratedField::MsgType),
              "deviceInfo" | "device_info" => Ok(GeneratedField::DeviceInfo),
              "setupInfo" | "setup_info" => Ok(GeneratedField::SetupInfo),
              "otaCfg" | "ota_cfg" => Ok(GeneratedField::OtaCfg),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AppDongle;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AppDongle")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AppDongle, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut msg_type__ = None;
        let mut device_info__ = None;
        let mut setup_info__ = None;
        let mut ota_cfg__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MsgType => {
              if msg_type__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgType"));
              }
              msg_type__ = Some(map_.next_value::<app_dongle::MsgType>()? as i32);
            }
            GeneratedField::DeviceInfo => {
              if device_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfo"));
              }
              device_info__ = map_.next_value()?;
            }
            GeneratedField::SetupInfo => {
              if setup_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("setupInfo"));
              }
              setup_info__ = map_.next_value()?;
            }
            GeneratedField::OtaCfg => {
              if ota_cfg__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaCfg"));
              }
              ota_cfg__ = map_.next_value()?;
            }
          }
        }
        Ok(AppDongle {
          msg_id: msg_id__.unwrap_or_default(),
          msg_type: msg_type__.unwrap_or_default(),
          device_info: device_info__,
          setup_info: setup_info__,
          ota_cfg: ota_cfg__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AppDongle", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for app_dongle::MsgType {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "NONE",
      Self::ConfigSet => "CONFIG_SET",
      Self::ConfigGet => "CONFIG_GET",
      Self::PairSet => "PAIR_SET",
      Self::PairGet => "PAIR_GET",
      Self::PairStat => "PAIR_STAT",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for app_dongle::MsgType {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "NONE",
      "CONFIG_SET",
      "CONFIG_GET",
      "PAIR_SET",
      "PAIR_GET",
      "PAIR_STAT",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = app_dongle::MsgType;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NONE" => Ok(app_dongle::MsgType::None),
          "CONFIG_SET" => Ok(app_dongle::MsgType::ConfigSet),
          "CONFIG_GET" => Ok(app_dongle::MsgType::ConfigGet),
          "PAIR_SET" => Ok(app_dongle::MsgType::PairSet),
          "PAIR_GET" => Ok(app_dongle::MsgType::PairGet),
          "PAIR_STAT" => Ok(app_dongle::MsgType::PairStat),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for AppSensor {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.msg_cmd != 0 {
      len += 1;
    }
    if self.device_info_cfg.is_some() {
      len += 1;
    }
    if self.ble_conf.is_some() {
      len += 1;
    }
    if self.ota_cfg.is_some() {
      len += 1;
    }
    if self.imu_config.is_some() {
      len += 1;
    }
    if self.mag_config.is_some() {
      len += 1;
    }
    if self.afe_config.is_some() {
      len += 1;
    }
    if self.acc_config.is_some() {
      len += 1;
    }
    if self.flex_config.is_some() {
      len += 1;
    }
    if self.ppg_config.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AppSensor", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if self.msg_cmd != 0 {
      let v = ConfigReqType::try_from(self.msg_cmd)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.msg_cmd)))?;
      struct_ser.serialize_field("msgCmd", &v)?;
    }
    if let Some(v) = self.device_info_cfg.as_ref() {
      struct_ser.serialize_field("deviceInfoCfg", v)?;
    }
    if let Some(v) = self.ble_conf.as_ref() {
      struct_ser.serialize_field("bleConf", v)?;
    }
    if let Some(v) = self.ota_cfg.as_ref() {
      struct_ser.serialize_field("otaCfg", v)?;
    }
    if let Some(v) = self.imu_config.as_ref() {
      struct_ser.serialize_field("imuConfig", v)?;
    }
    if let Some(v) = self.mag_config.as_ref() {
      struct_ser.serialize_field("magConfig", v)?;
    }
    if let Some(v) = self.afe_config.as_ref() {
      struct_ser.serialize_field("afeConfig", v)?;
    }
    if let Some(v) = self.acc_config.as_ref() {
      struct_ser.serialize_field("accConfig", v)?;
    }
    if let Some(v) = self.flex_config.as_ref() {
      struct_ser.serialize_field("flexConfig", v)?;
    }
    if let Some(v) = self.ppg_config.as_ref() {
      struct_ser.serialize_field("ppgConfig", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AppSensor {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "msg_cmd",
      "msgCmd",
      "device_info_cfg",
      "deviceInfoCfg",
      "ble_conf",
      "bleConf",
      "ota_cfg",
      "otaCfg",
      "imu_config",
      "imuConfig",
      "mag_config",
      "magConfig",
      "afe_config",
      "afeConfig",
      "acc_config",
      "accConfig",
      "flex_config",
      "flexConfig",
      "ppg_config",
      "ppgConfig",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      MsgCmd,
      DeviceInfoCfg,
      BleConf,
      OtaCfg,
      ImuConfig,
      MagConfig,
      AfeConfig,
      AccConfig,
      FlexConfig,
      PpgConfig,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "msgCmd" | "msg_cmd" => Ok(GeneratedField::MsgCmd),
              "deviceInfoCfg" | "device_info_cfg" => Ok(GeneratedField::DeviceInfoCfg),
              "bleConf" | "ble_conf" => Ok(GeneratedField::BleConf),
              "otaCfg" | "ota_cfg" => Ok(GeneratedField::OtaCfg),
              "imuConfig" | "imu_config" => Ok(GeneratedField::ImuConfig),
              "magConfig" | "mag_config" => Ok(GeneratedField::MagConfig),
              "afeConfig" | "afe_config" => Ok(GeneratedField::AfeConfig),
              "accConfig" | "acc_config" => Ok(GeneratedField::AccConfig),
              "flexConfig" | "flex_config" => Ok(GeneratedField::FlexConfig),
              "ppgConfig" | "ppg_config" => Ok(GeneratedField::PpgConfig),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AppSensor;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AppSensor")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AppSensor, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut msg_cmd__ = None;
        let mut device_info_cfg__ = None;
        let mut ble_conf__ = None;
        let mut ota_cfg__ = None;
        let mut imu_config__ = None;
        let mut mag_config__ = None;
        let mut afe_config__ = None;
        let mut acc_config__ = None;
        let mut flex_config__ = None;
        let mut ppg_config__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MsgCmd => {
              if msg_cmd__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgCmd"));
              }
              msg_cmd__ = Some(map_.next_value::<ConfigReqType>()? as i32);
            }
            GeneratedField::DeviceInfoCfg => {
              if device_info_cfg__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfoCfg"));
              }
              device_info_cfg__ = map_.next_value()?;
            }
            GeneratedField::BleConf => {
              if ble_conf__.is_some() {
                return Err(serde::de::Error::duplicate_field("bleConf"));
              }
              ble_conf__ = map_.next_value()?;
            }
            GeneratedField::OtaCfg => {
              if ota_cfg__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaCfg"));
              }
              ota_cfg__ = map_.next_value()?;
            }
            GeneratedField::ImuConfig => {
              if imu_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuConfig"));
              }
              imu_config__ = map_.next_value()?;
            }
            GeneratedField::MagConfig => {
              if mag_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("magConfig"));
              }
              mag_config__ = map_.next_value()?;
            }
            GeneratedField::AfeConfig => {
              if afe_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("afeConfig"));
              }
              afe_config__ = map_.next_value()?;
            }
            GeneratedField::AccConfig => {
              if acc_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("accConfig"));
              }
              acc_config__ = map_.next_value()?;
            }
            GeneratedField::FlexConfig => {
              if flex_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexConfig"));
              }
              flex_config__ = map_.next_value()?;
            }
            GeneratedField::PpgConfig => {
              if ppg_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("ppgConfig"));
              }
              ppg_config__ = map_.next_value()?;
            }
          }
        }
        Ok(AppSensor {
          msg_id: msg_id__.unwrap_or_default(),
          msg_cmd: msg_cmd__.unwrap_or_default(),
          device_info_cfg: device_info_cfg__,
          ble_conf: ble_conf__,
          ota_cfg: ota_cfg__,
          imu_config: imu_config__,
          mag_config: mag_config__,
          afe_config: afe_config__,
          acc_config: acc_config__,
          flex_config: flex_config__,
          ppg_config: ppg_config__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AppSensor", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for AppToControlBox {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.msg_cmd != 0 {
      len += 1;
    }
    if self.device_info_cfg.is_some() {
      len += 1;
    }
    if self.ota_cfg.is_some() {
      len += 1;
    }
    if self.imu_config.is_some() {
      len += 1;
    }
    if self.mag_config.is_some() {
      len += 1;
    }
    if self.afe_config.is_some() {
      len += 1;
    }
    if self.acc_config.is_some() {
      len += 1;
    }
    if self.hall_config.is_some() {
      len += 1;
    }
    if self.flex_config.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.AppToControlBox", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if self.msg_cmd != 0 {
      let v = ConfigReqType::try_from(self.msg_cmd)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.msg_cmd)))?;
      struct_ser.serialize_field("msgCmd", &v)?;
    }
    if let Some(v) = self.device_info_cfg.as_ref() {
      struct_ser.serialize_field("deviceInfoCfg", v)?;
    }
    if let Some(v) = self.ota_cfg.as_ref() {
      struct_ser.serialize_field("otaCfg", v)?;
    }
    if let Some(v) = self.imu_config.as_ref() {
      struct_ser.serialize_field("imuConfig", v)?;
    }
    if let Some(v) = self.mag_config.as_ref() {
      struct_ser.serialize_field("magConfig", v)?;
    }
    if let Some(v) = self.afe_config.as_ref() {
      struct_ser.serialize_field("afeConfig", v)?;
    }
    if let Some(v) = self.acc_config.as_ref() {
      struct_ser.serialize_field("accConfig", v)?;
    }
    if let Some(v) = self.hall_config.as_ref() {
      struct_ser.serialize_field("hallConfig", v)?;
    }
    if let Some(v) = self.flex_config.as_ref() {
      struct_ser.serialize_field("flexConfig", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for AppToControlBox {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "msg_cmd",
      "msgCmd",
      "device_info_cfg",
      "deviceInfoCfg",
      "ota_cfg",
      "otaCfg",
      "imu_config",
      "imuConfig",
      "mag_config",
      "magConfig",
      "afe_config",
      "afeConfig",
      "acc_config",
      "accConfig",
      "hall_config",
      "hallConfig",
      "flex_config",
      "flexConfig",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      MsgCmd,
      DeviceInfoCfg,
      OtaCfg,
      ImuConfig,
      MagConfig,
      AfeConfig,
      AccConfig,
      HallConfig,
      FlexConfig,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "msgCmd" | "msg_cmd" => Ok(GeneratedField::MsgCmd),
              "deviceInfoCfg" | "device_info_cfg" => Ok(GeneratedField::DeviceInfoCfg),
              "otaCfg" | "ota_cfg" => Ok(GeneratedField::OtaCfg),
              "imuConfig" | "imu_config" => Ok(GeneratedField::ImuConfig),
              "magConfig" | "mag_config" => Ok(GeneratedField::MagConfig),
              "afeConfig" | "afe_config" => Ok(GeneratedField::AfeConfig),
              "accConfig" | "acc_config" => Ok(GeneratedField::AccConfig),
              "hallConfig" | "hall_config" => Ok(GeneratedField::HallConfig),
              "flexConfig" | "flex_config" => Ok(GeneratedField::FlexConfig),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = AppToControlBox;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.AppToControlBox")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<AppToControlBox, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut msg_cmd__ = None;
        let mut device_info_cfg__ = None;
        let mut ota_cfg__ = None;
        let mut imu_config__ = None;
        let mut mag_config__ = None;
        let mut afe_config__ = None;
        let mut acc_config__ = None;
        let mut hall_config__ = None;
        let mut flex_config__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MsgCmd => {
              if msg_cmd__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgCmd"));
              }
              msg_cmd__ = Some(map_.next_value::<ConfigReqType>()? as i32);
            }
            GeneratedField::DeviceInfoCfg => {
              if device_info_cfg__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfoCfg"));
              }
              device_info_cfg__ = map_.next_value()?;
            }
            GeneratedField::OtaCfg => {
              if ota_cfg__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaCfg"));
              }
              ota_cfg__ = map_.next_value()?;
            }
            GeneratedField::ImuConfig => {
              if imu_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuConfig"));
              }
              imu_config__ = map_.next_value()?;
            }
            GeneratedField::MagConfig => {
              if mag_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("magConfig"));
              }
              mag_config__ = map_.next_value()?;
            }
            GeneratedField::AfeConfig => {
              if afe_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("afeConfig"));
              }
              afe_config__ = map_.next_value()?;
            }
            GeneratedField::AccConfig => {
              if acc_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("accConfig"));
              }
              acc_config__ = map_.next_value()?;
            }
            GeneratedField::HallConfig => {
              if hall_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallConfig"));
              }
              hall_config__ = map_.next_value()?;
            }
            GeneratedField::FlexConfig => {
              if flex_config__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexConfig"));
              }
              flex_config__ = map_.next_value()?;
            }
          }
        }
        Ok(AppToControlBox {
          msg_id: msg_id__.unwrap_or_default(),
          msg_cmd: msg_cmd__.unwrap_or_default(),
          device_info_cfg: device_info_cfg__,
          ota_cfg: ota_cfg__,
          imu_config: imu_config__,
          mag_config: mag_config__,
          afe_config: afe_config__,
          acc_config: acc_config__,
          hall_config: hall_config__,
          flex_config: flex_config__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.AppToControlBox", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for BleConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if !self.device_name.is_empty() {
      len += 1;
    }
    if !self.mac_address.is_empty() {
      len += 1;
    }
    if self.pair_cmd != 0 {
      len += 1;
    }
    if !self.pair_key.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.BleConfig", len)?;
    if !self.device_name.is_empty() {
      struct_ser.serialize_field("deviceName", &self.device_name)?;
    }
    if !self.mac_address.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "macAddress",
        pbjson::private::base64::encode(&self.mac_address).as_str(),
      )?;
    }
    if self.pair_cmd != 0 {
      let v = ble_config::PairCmd::try_from(self.pair_cmd)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.pair_cmd)))?;
      struct_ser.serialize_field("pairCmd", &v)?;
    }
    if !self.pair_key.is_empty() {
      struct_ser.serialize_field("pairKey", &self.pair_key)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for BleConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "device_name",
      "deviceName",
      "mac_address",
      "macAddress",
      "pair_cmd",
      "pairCmd",
      "pair_key",
      "pairKey",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      DeviceName,
      MacAddress,
      PairCmd,
      PairKey,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "deviceName" | "device_name" => Ok(GeneratedField::DeviceName),
              "macAddress" | "mac_address" => Ok(GeneratedField::MacAddress),
              "pairCmd" | "pair_cmd" => Ok(GeneratedField::PairCmd),
              "pairKey" | "pair_key" => Ok(GeneratedField::PairKey),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = BleConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.BleConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<BleConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut device_name__ = None;
        let mut mac_address__ = None;
        let mut pair_cmd__ = None;
        let mut pair_key__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::DeviceName => {
              if device_name__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceName"));
              }
              device_name__ = Some(map_.next_value()?);
            }
            GeneratedField::MacAddress => {
              if mac_address__.is_some() {
                return Err(serde::de::Error::duplicate_field("macAddress"));
              }
              mac_address__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::PairCmd => {
              if pair_cmd__.is_some() {
                return Err(serde::de::Error::duplicate_field("pairCmd"));
              }
              pair_cmd__ = Some(map_.next_value::<ble_config::PairCmd>()? as i32);
            }
            GeneratedField::PairKey => {
              if pair_key__.is_some() {
                return Err(serde::de::Error::duplicate_field("pairKey"));
              }
              pair_key__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(BleConfig {
          device_name: device_name__.unwrap_or_default(),
          mac_address: mac_address__.unwrap_or_default(),
          pair_cmd: pair_cmd__.unwrap_or_default(),
          pair_key: pair_key__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.BleConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ble_config::PairCmd {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::Unknown => "PAIR_CMD_UNKNOWN",
      Self::Pair => "PAIR_CMD_PAIR",
      Self::Verify => "PAIR_CMD_VERIFY",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ble_config::PairCmd {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["PAIR_CMD_UNKNOWN", "PAIR_CMD_PAIR", "PAIR_CMD_VERIFY"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ble_config::PairCmd;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PAIR_CMD_UNKNOWN" => Ok(ble_config::PairCmd::Unknown),
          "PAIR_CMD_PAIR" => Ok(ble_config::PairCmd::Pair),
          "PAIR_CMD_VERIFY" => Ok(ble_config::PairCmd::Verify),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for BoxSensorType {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::SensNone => "SENS_NONE",
      Self::SensImu => "SENS_IMU",
      Self::SensAcc => "SENS_ACC",
      Self::SensHall => "SENS_HALL",
      Self::SensFlex => "SENS_FLEX",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for BoxSensorType {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "SENS_NONE",
      "SENS_IMU",
      "SENS_ACC",
      "SENS_HALL",
      "SENS_FLEX",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = BoxSensorType;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "SENS_NONE" => Ok(BoxSensorType::SensNone),
          "SENS_IMU" => Ok(BoxSensorType::SensImu),
          "SENS_ACC" => Ok(BoxSensorType::SensAcc),
          "SENS_HALL" => Ok(BoxSensorType::SensHall),
          "SENS_FLEX" => Ok(BoxSensorType::SensFlex),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for ConfigReqType {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ReqNone => "REQ_NONE",
      Self::GetDeviceInfo => "GET_DEVICE_INFO",
      Self::SetDeviceInfo => "SET_DEVICE_INFO",
      Self::GetPortStat => "GET_PORT_STAT",
      Self::GetSensorConfig => "GET_SENSOR_CONFIG",
      Self::StartDataStream => "START_DATA_STREAM",
      Self::StopDataStream => "STOP_DATA_STREAM",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ConfigReqType {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "REQ_NONE",
      "GET_DEVICE_INFO",
      "SET_DEVICE_INFO",
      "GET_PORT_STAT",
      "GET_SENSOR_CONFIG",
      "START_DATA_STREAM",
      "STOP_DATA_STREAM",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ConfigReqType;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "REQ_NONE" => Ok(ConfigReqType::ReqNone),
          "GET_DEVICE_INFO" => Ok(ConfigReqType::GetDeviceInfo),
          "SET_DEVICE_INFO" => Ok(ConfigReqType::SetDeviceInfo),
          "GET_PORT_STAT" => Ok(ConfigReqType::GetPortStat),
          "GET_SENSOR_CONFIG" => Ok(ConfigReqType::GetSensorConfig),
          "START_DATA_STREAM" => Ok(ConfigReqType::StartDataStream),
          "STOP_DATA_STREAM" => Ok(ConfigReqType::StopDataStream),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for ConfigRespError {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ConfigErrSuccess => "CONFIG_ERR_SUCCESS",
      Self::ConfigErrHardware => "CONFIG_ERR_HARDWARE",
      Self::ConfigErrParameter => "CONFIG_ERR_PARAMETER",
      Self::ConfigErrUnknown => "CONFIG_ERR_UNKNOWN",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ConfigRespError {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "CONFIG_ERR_SUCCESS",
      "CONFIG_ERR_HARDWARE",
      "CONFIG_ERR_PARAMETER",
      "CONFIG_ERR_UNKNOWN",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ConfigRespError;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "CONFIG_ERR_SUCCESS" => Ok(ConfigRespError::ConfigErrSuccess),
          "CONFIG_ERR_HARDWARE" => Ok(ConfigRespError::ConfigErrHardware),
          "CONFIG_ERR_PARAMETER" => Ok(ConfigRespError::ConfigErrParameter),
          "CONFIG_ERR_UNKNOWN" => Ok(ConfigRespError::ConfigErrUnknown),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for ControlBoxToApp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.device_info.is_some() {
      len += 1;
    }
    if self.device_event != 0 {
      len += 1;
    }
    if self.port_stat.is_some() {
      len += 1;
    }
    if self.ota_resp.is_some() {
      len += 1;
    }
    if self.imu_data.is_some() {
      len += 1;
    }
    if self.imu_resp.is_some() {
      len += 1;
    }
    if self.acc_data.is_some() {
      len += 1;
    }
    if self.acc_resp.is_some() {
      len += 1;
    }
    if self.flex_data.is_some() {
      len += 1;
    }
    if self.flex_resp.is_some() {
      len += 1;
    }
    if self.hall_data.is_some() {
      len += 1;
    }
    if self.hall_resp.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.ControlBoxToApp", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if let Some(v) = self.device_info.as_ref() {
      struct_ser.serialize_field("deviceInfo", v)?;
    }
    if self.device_event != 0 {
      let v = DeviceEvent::try_from(self.device_event)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.device_event)))?;
      struct_ser.serialize_field("deviceEvent", &v)?;
    }
    if let Some(v) = self.port_stat.as_ref() {
      struct_ser.serialize_field("portStat", v)?;
    }
    if let Some(v) = self.ota_resp.as_ref() {
      struct_ser.serialize_field("otaResp", v)?;
    }
    if let Some(v) = self.imu_data.as_ref() {
      struct_ser.serialize_field("imuData", v)?;
    }
    if let Some(v) = self.imu_resp.as_ref() {
      struct_ser.serialize_field("imuResp", v)?;
    }
    if let Some(v) = self.acc_data.as_ref() {
      struct_ser.serialize_field("accData", v)?;
    }
    if let Some(v) = self.acc_resp.as_ref() {
      struct_ser.serialize_field("accResp", v)?;
    }
    if let Some(v) = self.flex_data.as_ref() {
      struct_ser.serialize_field("flexData", v)?;
    }
    if let Some(v) = self.flex_resp.as_ref() {
      struct_ser.serialize_field("flexResp", v)?;
    }
    if let Some(v) = self.hall_data.as_ref() {
      struct_ser.serialize_field("hallData", v)?;
    }
    if let Some(v) = self.hall_resp.as_ref() {
      struct_ser.serialize_field("hallResp", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ControlBoxToApp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "device_info",
      "deviceInfo",
      "device_event",
      "deviceEvent",
      "port_stat",
      "portStat",
      "ota_resp",
      "otaResp",
      "imu_data",
      "imuData",
      "imu_resp",
      "imuResp",
      "acc_data",
      "accData",
      "acc_resp",
      "accResp",
      "flex_data",
      "flexData",
      "flex_resp",
      "flexResp",
      "hall_data",
      "hallData",
      "hall_resp",
      "hallResp",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      DeviceInfo,
      DeviceEvent,
      PortStat,
      OtaResp,
      ImuData,
      ImuResp,
      AccData,
      AccResp,
      FlexData,
      FlexResp,
      HallData,
      HallResp,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "deviceInfo" | "device_info" => Ok(GeneratedField::DeviceInfo),
              "deviceEvent" | "device_event" => Ok(GeneratedField::DeviceEvent),
              "portStat" | "port_stat" => Ok(GeneratedField::PortStat),
              "otaResp" | "ota_resp" => Ok(GeneratedField::OtaResp),
              "imuData" | "imu_data" => Ok(GeneratedField::ImuData),
              "imuResp" | "imu_resp" => Ok(GeneratedField::ImuResp),
              "accData" | "acc_data" => Ok(GeneratedField::AccData),
              "accResp" | "acc_resp" => Ok(GeneratedField::AccResp),
              "flexData" | "flex_data" => Ok(GeneratedField::FlexData),
              "flexResp" | "flex_resp" => Ok(GeneratedField::FlexResp),
              "hallData" | "hall_data" => Ok(GeneratedField::HallData),
              "hallResp" | "hall_resp" => Ok(GeneratedField::HallResp),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ControlBoxToApp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.ControlBoxToApp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ControlBoxToApp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut device_info__ = None;
        let mut device_event__ = None;
        let mut port_stat__ = None;
        let mut ota_resp__ = None;
        let mut imu_data__ = None;
        let mut imu_resp__ = None;
        let mut acc_data__ = None;
        let mut acc_resp__ = None;
        let mut flex_data__ = None;
        let mut flex_resp__ = None;
        let mut hall_data__ = None;
        let mut hall_resp__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::DeviceInfo => {
              if device_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfo"));
              }
              device_info__ = map_.next_value()?;
            }
            GeneratedField::DeviceEvent => {
              if device_event__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceEvent"));
              }
              device_event__ = Some(map_.next_value::<DeviceEvent>()? as i32);
            }
            GeneratedField::PortStat => {
              if port_stat__.is_some() {
                return Err(serde::de::Error::duplicate_field("portStat"));
              }
              port_stat__ = map_.next_value()?;
            }
            GeneratedField::OtaResp => {
              if ota_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaResp"));
              }
              ota_resp__ = map_.next_value()?;
            }
            GeneratedField::ImuData => {
              if imu_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuData"));
              }
              imu_data__ = map_.next_value()?;
            }
            GeneratedField::ImuResp => {
              if imu_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuResp"));
              }
              imu_resp__ = map_.next_value()?;
            }
            GeneratedField::AccData => {
              if acc_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accData"));
              }
              acc_data__ = map_.next_value()?;
            }
            GeneratedField::AccResp => {
              if acc_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("accResp"));
              }
              acc_resp__ = map_.next_value()?;
            }
            GeneratedField::FlexData => {
              if flex_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexData"));
              }
              flex_data__ = map_.next_value()?;
            }
            GeneratedField::FlexResp => {
              if flex_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexResp"));
              }
              flex_resp__ = map_.next_value()?;
            }
            GeneratedField::HallData => {
              if hall_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallData"));
              }
              hall_data__ = map_.next_value()?;
            }
            GeneratedField::HallResp => {
              if hall_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallResp"));
              }
              hall_resp__ = map_.next_value()?;
            }
          }
        }
        Ok(ControlBoxToApp {
          msg_id: msg_id__.unwrap_or_default(),
          device_info: device_info__,
          device_event: device_event__.unwrap_or_default(),
          port_stat: port_stat__,
          ota_resp: ota_resp__,
          imu_data: imu_data__,
          imu_resp: imu_resp__,
          acc_data: acc_data__,
          acc_resp: acc_resp__,
          flex_data: flex_data__,
          flex_resp: flex_resp__,
          hall_data: hall_data__,
          hall_resp: hall_resp__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.ControlBoxToApp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for CtrlBoxPort {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::PortNone => "PORT_NONE",
      Self::PortA => "PORT_A",
      Self::PortB => "PORT_B",
      Self::PortC => "PORT_C",
      Self::PortD => "PORT_D",
      Self::PortE => "PORT_E",
      Self::PortF => "PORT_F",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for CtrlBoxPort {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "PORT_NONE",
      "PORT_A",
      "PORT_B",
      "PORT_C",
      "PORT_D",
      "PORT_E",
      "PORT_F",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = CtrlBoxPort;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PORT_NONE" => Ok(CtrlBoxPort::PortNone),
          "PORT_A" => Ok(CtrlBoxPort::PortA),
          "PORT_B" => Ok(CtrlBoxPort::PortB),
          "PORT_C" => Ok(CtrlBoxPort::PortC),
          "PORT_D" => Ok(CtrlBoxPort::PortD),
          "PORT_E" => Ok(CtrlBoxPort::PortE),
          "PORT_F" => Ok(CtrlBoxPort::PortF),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for DeviceEvent {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "NONE",
      Self::LeadOn => "LEAD_ON",
      Self::LeadOff => "LEAD_OFF",
      Self::ButtonPwoff => "BUTTON_PWOFF",
      Self::TimeoutPwoff => "TIMEOUT_PWOFF",
      Self::LowPower => "LOW_POWER",
      Self::HardwareErr => "HARDWARE_ERR",
      Self::PortConnected => "PORT_CONNECTED",
      Self::PortDisconnected => "PORT_DISCONNECTED",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for DeviceEvent {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "NONE",
      "LEAD_ON",
      "LEAD_OFF",
      "BUTTON_PWOFF",
      "TIMEOUT_PWOFF",
      "LOW_POWER",
      "HARDWARE_ERR",
      "PORT_CONNECTED",
      "PORT_DISCONNECTED",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = DeviceEvent;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NONE" => Ok(DeviceEvent::None),
          "LEAD_ON" => Ok(DeviceEvent::LeadOn),
          "LEAD_OFF" => Ok(DeviceEvent::LeadOff),
          "BUTTON_PWOFF" => Ok(DeviceEvent::ButtonPwoff),
          "TIMEOUT_PWOFF" => Ok(DeviceEvent::TimeoutPwoff),
          "LOW_POWER" => Ok(DeviceEvent::LowPower),
          "HARDWARE_ERR" => Ok(DeviceEvent::HardwareErr),
          "PORT_CONNECTED" => Ok(DeviceEvent::PortConnected),
          "PORT_DISCONNECTED" => Ok(DeviceEvent::PortDisconnected),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for DeviceInfo {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.sensor_type != 0 {
      len += 1;
    }
    if !self.model.is_empty() {
      len += 1;
    }
    if !self.sn.is_empty() {
      len += 1;
    }
    if !self.hw_version.is_empty() {
      len += 1;
    }
    if !self.fw_version.is_empty() {
      len += 1;
    }
    if !self.build_time.is_empty() {
      len += 1;
    }
    if !self.commit_hash.is_empty() {
      len += 1;
    }
    if self.sensor_features != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.DeviceInfo", len)?;
    if self.sensor_type != 0 {
      let v = SensorType::try_from(self.sensor_type)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.sensor_type)))?;
      struct_ser.serialize_field("sensorType", &v)?;
    }
    if !self.model.is_empty() {
      struct_ser.serialize_field("model", &self.model)?;
    }
    if !self.sn.is_empty() {
      struct_ser.serialize_field("sn", &self.sn)?;
    }
    if !self.hw_version.is_empty() {
      struct_ser.serialize_field("hwVersion", &self.hw_version)?;
    }
    if !self.fw_version.is_empty() {
      struct_ser.serialize_field("fwVersion", &self.fw_version)?;
    }
    if !self.build_time.is_empty() {
      struct_ser.serialize_field("buildTime", &self.build_time)?;
    }
    if !self.commit_hash.is_empty() {
      struct_ser.serialize_field("commitHash", &self.commit_hash)?;
    }
    if self.sensor_features != 0 {
      struct_ser.serialize_field("sensorFeatures", &self.sensor_features)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for DeviceInfo {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "sensor_type",
      "sensorType",
      "model",
      "sn",
      "hw_version",
      "hwVersion",
      "fw_version",
      "fwVersion",
      "build_time",
      "buildTime",
      "commit_hash",
      "commitHash",
      "sensor_features",
      "sensorFeatures",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SensorType,
      Model,
      Sn,
      HwVersion,
      FwVersion,
      BuildTime,
      CommitHash,
      SensorFeatures,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "sensorType" | "sensor_type" => Ok(GeneratedField::SensorType),
              "model" => Ok(GeneratedField::Model),
              "sn" => Ok(GeneratedField::Sn),
              "hwVersion" | "hw_version" => Ok(GeneratedField::HwVersion),
              "fwVersion" | "fw_version" => Ok(GeneratedField::FwVersion),
              "buildTime" | "build_time" => Ok(GeneratedField::BuildTime),
              "commitHash" | "commit_hash" => Ok(GeneratedField::CommitHash),
              "sensorFeatures" | "sensor_features" => Ok(GeneratedField::SensorFeatures),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = DeviceInfo;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.DeviceInfo")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<DeviceInfo, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut sensor_type__ = None;
        let mut model__ = None;
        let mut sn__ = None;
        let mut hw_version__ = None;
        let mut fw_version__ = None;
        let mut build_time__ = None;
        let mut commit_hash__ = None;
        let mut sensor_features__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SensorType => {
              if sensor_type__.is_some() {
                return Err(serde::de::Error::duplicate_field("sensorType"));
              }
              sensor_type__ = Some(map_.next_value::<SensorType>()? as i32);
            }
            GeneratedField::Model => {
              if model__.is_some() {
                return Err(serde::de::Error::duplicate_field("model"));
              }
              model__ = Some(map_.next_value()?);
            }
            GeneratedField::Sn => {
              if sn__.is_some() {
                return Err(serde::de::Error::duplicate_field("sn"));
              }
              sn__ = Some(map_.next_value()?);
            }
            GeneratedField::HwVersion => {
              if hw_version__.is_some() {
                return Err(serde::de::Error::duplicate_field("hwVersion"));
              }
              hw_version__ = Some(map_.next_value()?);
            }
            GeneratedField::FwVersion => {
              if fw_version__.is_some() {
                return Err(serde::de::Error::duplicate_field("fwVersion"));
              }
              fw_version__ = Some(map_.next_value()?);
            }
            GeneratedField::BuildTime => {
              if build_time__.is_some() {
                return Err(serde::de::Error::duplicate_field("buildTime"));
              }
              build_time__ = Some(map_.next_value()?);
            }
            GeneratedField::CommitHash => {
              if commit_hash__.is_some() {
                return Err(serde::de::Error::duplicate_field("commitHash"));
              }
              commit_hash__ = Some(map_.next_value()?);
            }
            GeneratedField::SensorFeatures => {
              if sensor_features__.is_some() {
                return Err(serde::de::Error::duplicate_field("sensorFeatures"));
              }
              sensor_features__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(DeviceInfo {
          sensor_type: sensor_type__.unwrap_or_default(),
          model: model__.unwrap_or_default(),
          sn: sn__.unwrap_or_default(),
          hw_version: hw_version__.unwrap_or_default(),
          fw_version: fw_version__.unwrap_or_default(),
          build_time: build_time__.unwrap_or_default(),
          commit_hash: commit_hash__.unwrap_or_default(),
          sensor_features: sensor_features__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.DeviceInfo", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for DeviceInfoConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if !self.model.is_empty() {
      len += 1;
    }
    if !self.sn.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.DeviceInfoConfig", len)?;
    if !self.model.is_empty() {
      struct_ser.serialize_field("model", &self.model)?;
    }
    if !self.sn.is_empty() {
      struct_ser.serialize_field("sn", &self.sn)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for DeviceInfoConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["model", "sn"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Model,
      Sn,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "model" => Ok(GeneratedField::Model),
              "sn" => Ok(GeneratedField::Sn),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = DeviceInfoConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.DeviceInfoConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<DeviceInfoConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut model__ = None;
        let mut sn__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Model => {
              if model__.is_some() {
                return Err(serde::de::Error::duplicate_field("model"));
              }
              model__ = Some(map_.next_value()?);
            }
            GeneratedField::Sn => {
              if sn__.is_some() {
                return Err(serde::de::Error::duplicate_field("sn"));
              }
              sn__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(DeviceInfoConfig {
          model: model__.unwrap_or_default(),
          sn: sn__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct(
      "tech.brainco.edu.DeviceInfoConfig",
      FIELDS,
      GeneratedVisitor,
    )
  }
}
impl serde::Serialize for DeviceSetupInfo {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if !self.model.is_empty() {
      len += 1;
    }
    if !self.sn.is_empty() {
      len += 1;
    }
    if !self.mac_address.is_empty() {
      len += 1;
    }
    if self.usb_info.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.DeviceSetupInfo", len)?;
    if !self.model.is_empty() {
      struct_ser.serialize_field("model", &self.model)?;
    }
    if !self.sn.is_empty() {
      struct_ser.serialize_field("sn", &self.sn)?;
    }
    if !self.mac_address.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "macAddress",
        pbjson::private::base64::encode(&self.mac_address).as_str(),
      )?;
    }
    if let Some(v) = self.usb_info.as_ref() {
      struct_ser.serialize_field("usbInfo", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for DeviceSetupInfo {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "model",
      "sn",
      "mac_address",
      "macAddress",
      "usb_info",
      "usbInfo",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Model,
      Sn,
      MacAddress,
      UsbInfo,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "model" => Ok(GeneratedField::Model),
              "sn" => Ok(GeneratedField::Sn),
              "macAddress" | "mac_address" => Ok(GeneratedField::MacAddress),
              "usbInfo" | "usb_info" => Ok(GeneratedField::UsbInfo),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = DeviceSetupInfo;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.DeviceSetupInfo")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<DeviceSetupInfo, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut model__ = None;
        let mut sn__ = None;
        let mut mac_address__ = None;
        let mut usb_info__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Model => {
              if model__.is_some() {
                return Err(serde::de::Error::duplicate_field("model"));
              }
              model__ = Some(map_.next_value()?);
            }
            GeneratedField::Sn => {
              if sn__.is_some() {
                return Err(serde::de::Error::duplicate_field("sn"));
              }
              sn__ = Some(map_.next_value()?);
            }
            GeneratedField::MacAddress => {
              if mac_address__.is_some() {
                return Err(serde::de::Error::duplicate_field("macAddress"));
              }
              mac_address__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::UsbInfo => {
              if usb_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("usbInfo"));
              }
              usb_info__ = map_.next_value()?;
            }
          }
        }
        Ok(DeviceSetupInfo {
          model: model__.unwrap_or_default(),
          sn: sn__.unwrap_or_default(),
          mac_address: mac_address__.unwrap_or_default(),
          usb_info: usb_info__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.DeviceSetupInfo", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for DongleApp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.error != 0 {
      len += 1;
    }
    if self.device_info.is_some() {
      len += 1;
    }
    if self.setup_info.is_some() {
      len += 1;
    }
    if self.pairing_status != 0 {
      len += 1;
    }
    if self.ota_resp.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.DongleApp", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if self.error != 0 {
      let v = dongle_app::MsgErrorCode::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if let Some(v) = self.device_info.as_ref() {
      struct_ser.serialize_field("deviceInfo", v)?;
    }
    if let Some(v) = self.setup_info.as_ref() {
      struct_ser.serialize_field("setupInfo", v)?;
    }
    if self.pairing_status != 0 {
      let v = dongle_app::PairingStatus::try_from(self.pairing_status).map_err(|_| {
        serde::ser::Error::custom(format!("Invalid variant {}", self.pairing_status))
      })?;
      struct_ser.serialize_field("pairingStatus", &v)?;
    }
    if let Some(v) = self.ota_resp.as_ref() {
      struct_ser.serialize_field("otaResp", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for DongleApp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "error",
      "device_info",
      "deviceInfo",
      "setup_info",
      "setupInfo",
      "pairing_status",
      "pairingStatus",
      "ota_resp",
      "otaResp",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      Error,
      DeviceInfo,
      SetupInfo,
      PairingStatus,
      OtaResp,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "error" => Ok(GeneratedField::Error),
              "deviceInfo" | "device_info" => Ok(GeneratedField::DeviceInfo),
              "setupInfo" | "setup_info" => Ok(GeneratedField::SetupInfo),
              "pairingStatus" | "pairing_status" => Ok(GeneratedField::PairingStatus),
              "otaResp" | "ota_resp" => Ok(GeneratedField::OtaResp),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = DongleApp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.DongleApp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<DongleApp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut error__ = None;
        let mut device_info__ = None;
        let mut setup_info__ = None;
        let mut pairing_status__ = None;
        let mut ota_resp__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<dongle_app::MsgErrorCode>()? as i32);
            }
            GeneratedField::DeviceInfo => {
              if device_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfo"));
              }
              device_info__ = map_.next_value()?;
            }
            GeneratedField::SetupInfo => {
              if setup_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("setupInfo"));
              }
              setup_info__ = map_.next_value()?;
            }
            GeneratedField::PairingStatus => {
              if pairing_status__.is_some() {
                return Err(serde::de::Error::duplicate_field("pairingStatus"));
              }
              pairing_status__ = Some(map_.next_value::<dongle_app::PairingStatus>()? as i32);
            }
            GeneratedField::OtaResp => {
              if ota_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaResp"));
              }
              ota_resp__ = map_.next_value()?;
            }
          }
        }
        Ok(DongleApp {
          msg_id: msg_id__.unwrap_or_default(),
          error: error__.unwrap_or_default(),
          device_info: device_info__,
          setup_info: setup_info__,
          pairing_status: pairing_status__.unwrap_or_default(),
          ota_resp: ota_resp__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.DongleApp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for dongle_app::MsgErrorCode {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ErrNone => "ERR_NONE",
      Self::Success => "SUCCESS",
      Self::InvalidParam => "INVALID_PARAM",
      Self::NvsWriteFailed => "NVS_WRITE_FAILED",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for dongle_app::MsgErrorCode {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["ERR_NONE", "SUCCESS", "INVALID_PARAM", "NVS_WRITE_FAILED"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = dongle_app::MsgErrorCode;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "ERR_NONE" => Ok(dongle_app::MsgErrorCode::ErrNone),
          "SUCCESS" => Ok(dongle_app::MsgErrorCode::Success),
          "INVALID_PARAM" => Ok(dongle_app::MsgErrorCode::InvalidParam),
          "NVS_WRITE_FAILED" => Ok(dongle_app::MsgErrorCode::NvsWriteFailed),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for dongle_app::PairingStatus {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "NONE",
      Self::Idle => "IDLE",
      Self::Scanning => "SCANNING",
      Self::Connected => "CONNECTED",
      Self::Paired => "PAIRED",
      Self::PairRefused => "PAIR_REFUSED",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for dongle_app::PairingStatus {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "NONE",
      "IDLE",
      "SCANNING",
      "CONNECTED",
      "PAIRED",
      "PAIR_REFUSED",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = dongle_app::PairingStatus;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NONE" => Ok(dongle_app::PairingStatus::None),
          "IDLE" => Ok(dongle_app::PairingStatus::Idle),
          "SCANNING" => Ok(dongle_app::PairingStatus::Scanning),
          "CONNECTED" => Ok(dongle_app::PairingStatus::Connected),
          "PAIRED" => Ok(dongle_app::PairingStatus::Paired),
          "PAIR_REFUSED" => Ok(dongle_app::PairingStatus::PairRefused),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for FlexConfResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.config.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.FlexConfResp", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if let Some(v) = self.config.as_ref() {
      struct_ser.serialize_field("config", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for FlexConfResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["error", "config"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      Config,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "config" => Ok(GeneratedField::Config),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = FlexConfResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.FlexConfResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<FlexConfResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut config__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::Config => {
              if config__.is_some() {
                return Err(serde::de::Error::duplicate_field("config"));
              }
              config__ = map_.next_value()?;
            }
          }
        }
        Ok(FlexConfResp {
          error: error__.unwrap_or_default(),
          config: config__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.FlexConfResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for FlexConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.sample_rate != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.FlexConfig", len)?;
    if self.sample_rate != 0 {
      let v = SamplingRate::try_from(self.sample_rate)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.sample_rate)))?;
      struct_ser.serialize_field("sampleRate", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for FlexConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["sample_rate", "sampleRate"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SampleRate,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "sampleRate" | "sample_rate" => Ok(GeneratedField::SampleRate),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = FlexConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.FlexConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<FlexConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut sample_rate__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SampleRate => {
              if sample_rate__.is_some() {
                return Err(serde::de::Error::duplicate_field("sampleRate"));
              }
              sample_rate__ = Some(map_.next_value::<SamplingRate>()? as i32);
            }
          }
        }
        Ok(FlexConfig {
          sample_rate: sample_rate__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.FlexConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for FlexData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.seq_num != 0 {
      len += 1;
    }
    if !self.channel_adc_value.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.FlexData", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if !self.channel_adc_value.is_empty() {
      struct_ser.serialize_field(
        "channelAdcValue",
        &self
          .channel_adc_value
          .iter()
          .map(pbjson::private::base64::encode)
          .collect::<Vec<_>>(),
      )?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for FlexData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "error",
      "seq_num",
      "seqNum",
      "channel_adc_value",
      "channelAdcValue",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      SeqNum,
      ChannelAdcValue,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "channelAdcValue" | "channel_adc_value" => Ok(GeneratedField::ChannelAdcValue),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = FlexData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.FlexData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<FlexData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut seq_num__ = None;
        let mut channel_adc_value__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::ChannelAdcValue => {
              if channel_adc_value__.is_some() {
                return Err(serde::de::Error::duplicate_field("channelAdcValue"));
              }
              channel_adc_value__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::BytesDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
          }
        }
        Ok(FlexData {
          error: error__.unwrap_or_default(),
          seq_num: seq_num__.unwrap_or_default(),
          channel_adc_value: channel_adc_value__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.FlexData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for HallConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.hall_sr != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.HallConfig", len)?;
    if self.hall_sr != 0 {
      let v = SamplingRate::try_from(self.hall_sr)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.hall_sr)))?;
      struct_ser.serialize_field("hallSr", &v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for HallConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["hall_sr", "hallSr", "port"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      HallSr,
      Port,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "hallSr" | "hall_sr" => Ok(GeneratedField::HallSr),
              "port" => Ok(GeneratedField::Port),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = HallConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.HallConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<HallConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut hall_sr__ = None;
        let mut port__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::HallSr => {
              if hall_sr__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallSr"));
              }
              hall_sr__ = Some(map_.next_value::<SamplingRate>()? as i32);
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
          }
        }
        Ok(HallConfig {
          hall_sr: hall_sr__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.HallConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for HallData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.seq_num != 0 {
      len += 1;
    }
    if self.sample_rate != 0 {
      len += 1;
    }
    if !self.hall_value.is_empty() {
      len += 1;
    }
    if !self.magnetic_intensity.is_empty() {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.HallData", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if self.sample_rate != 0 {
      let v = SamplingRate::try_from(self.sample_rate)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.sample_rate)))?;
      struct_ser.serialize_field("sampleRate", &v)?;
    }
    if !self.hall_value.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "hallValue",
        pbjson::private::base64::encode(&self.hall_value).as_str(),
      )?;
    }
    if !self.magnetic_intensity.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "magneticIntensity",
        pbjson::private::base64::encode(&self.magnetic_intensity).as_str(),
      )?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for HallData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "error",
      "seq_num",
      "seqNum",
      "sample_rate",
      "sampleRate",
      "hall_value",
      "hallValue",
      "magnetic_intensity",
      "magneticIntensity",
      "port",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      SeqNum,
      SampleRate,
      HallValue,
      MagneticIntensity,
      Port,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "sampleRate" | "sample_rate" => Ok(GeneratedField::SampleRate),
              "hallValue" | "hall_value" => Ok(GeneratedField::HallValue),
              "magneticIntensity" | "magnetic_intensity" => Ok(GeneratedField::MagneticIntensity),
              "port" => Ok(GeneratedField::Port),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = HallData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.HallData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<HallData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut seq_num__ = None;
        let mut sample_rate__ = None;
        let mut hall_value__ = None;
        let mut magnetic_intensity__ = None;
        let mut port__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::SampleRate => {
              if sample_rate__.is_some() {
                return Err(serde::de::Error::duplicate_field("sampleRate"));
              }
              sample_rate__ = Some(map_.next_value::<SamplingRate>()? as i32);
            }
            GeneratedField::HallValue => {
              if hall_value__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallValue"));
              }
              hall_value__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MagneticIntensity => {
              if magnetic_intensity__.is_some() {
                return Err(serde::de::Error::duplicate_field("magneticIntensity"));
              }
              magnetic_intensity__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
          }
        }
        Ok(HallData {
          error: error__.unwrap_or_default(),
          seq_num: seq_num__.unwrap_or_default(),
          sample_rate: sample_rate__.unwrap_or_default(),
          hall_value: hall_value__.unwrap_or_default(),
          magnetic_intensity: magnetic_intensity__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.HallData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for HallResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.hall_conf.is_some() {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.HallResp", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if let Some(v) = self.hall_conf.as_ref() {
      struct_ser.serialize_field("hallConf", v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for HallResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["error", "hall_conf", "hallConf", "port"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      HallConf,
      Port,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "hallConf" | "hall_conf" => Ok(GeneratedField::HallConf),
              "port" => Ok(GeneratedField::Port),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = HallResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.HallResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<HallResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut hall_conf__ = None;
        let mut port__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::HallConf => {
              if hall_conf__.is_some() {
                return Err(serde::de::Error::duplicate_field("hallConf"));
              }
              hall_conf__ = map_.next_value()?;
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
          }
        }
        Ok(HallResp {
          error: error__.unwrap_or_default(),
          hall_conf: hall_conf__,
          port: port__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.HallResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ImuCalibration {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.acc_correction.is_some() {
      len += 1;
    }
    if self.gyro_correction.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.ImuCalibration", len)?;
    if let Some(v) = self.acc_correction.as_ref() {
      struct_ser.serialize_field("accCorrection", v)?;
    }
    if let Some(v) = self.gyro_correction.as_ref() {
      struct_ser.serialize_field("gyroCorrection", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ImuCalibration {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "acc_correction",
      "accCorrection",
      "gyro_correction",
      "gyroCorrection",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      AccCorrection,
      GyroCorrection,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "accCorrection" | "acc_correction" => Ok(GeneratedField::AccCorrection),
              "gyroCorrection" | "gyro_correction" => Ok(GeneratedField::GyroCorrection),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ImuCalibration;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.ImuCalibration")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ImuCalibration, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut acc_correction__ = None;
        let mut gyro_correction__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::AccCorrection => {
              if acc_correction__.is_some() {
                return Err(serde::de::Error::duplicate_field("accCorrection"));
              }
              acc_correction__ = map_.next_value()?;
            }
            GeneratedField::GyroCorrection => {
              if gyro_correction__.is_some() {
                return Err(serde::de::Error::duplicate_field("gyroCorrection"));
              }
              gyro_correction__ = map_.next_value()?;
            }
          }
        }
        Ok(ImuCalibration {
          acc_correction: acc_correction__,
          gyro_correction: gyro_correction__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.ImuCalibration", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ImuConfResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.error != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if self.config.is_some() {
      len += 1;
    }
    if self.acc_coefficient != 0. {
      len += 1;
    }
    if self.gyro_coefficient != 0. {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.ImuConfResp", len)?;
    if self.error != 0 {
      let v = ConfigRespError::try_from(self.error)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.error)))?;
      struct_ser.serialize_field("error", &v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if let Some(v) = self.config.as_ref() {
      struct_ser.serialize_field("config", v)?;
    }
    if self.acc_coefficient != 0. {
      struct_ser.serialize_field("accCoefficient", &self.acc_coefficient)?;
    }
    if self.gyro_coefficient != 0. {
      struct_ser.serialize_field("gyroCoefficient", &self.gyro_coefficient)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ImuConfResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "error",
      "port",
      "config",
      "acc_coefficient",
      "accCoefficient",
      "gyro_coefficient",
      "gyroCoefficient",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Error,
      Port,
      Config,
      AccCoefficient,
      GyroCoefficient,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "error" => Ok(GeneratedField::Error),
              "port" => Ok(GeneratedField::Port),
              "config" => Ok(GeneratedField::Config),
              "accCoefficient" | "acc_coefficient" => Ok(GeneratedField::AccCoefficient),
              "gyroCoefficient" | "gyro_coefficient" => Ok(GeneratedField::GyroCoefficient),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ImuConfResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.ImuConfResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ImuConfResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut error__ = None;
        let mut port__ = None;
        let mut config__ = None;
        let mut acc_coefficient__ = None;
        let mut gyro_coefficient__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Error => {
              if error__.is_some() {
                return Err(serde::de::Error::duplicate_field("error"));
              }
              error__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::Config => {
              if config__.is_some() {
                return Err(serde::de::Error::duplicate_field("config"));
              }
              config__ = map_.next_value()?;
            }
            GeneratedField::AccCoefficient => {
              if acc_coefficient__.is_some() {
                return Err(serde::de::Error::duplicate_field("accCoefficient"));
              }
              acc_coefficient__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::GyroCoefficient => {
              if gyro_coefficient__.is_some() {
                return Err(serde::de::Error::duplicate_field("gyroCoefficient"));
              }
              gyro_coefficient__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(ImuConfResp {
          error: error__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          config: config__,
          acc_coefficient: acc_coefficient__.unwrap_or_default(),
          gyro_coefficient: gyro_coefficient__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.ImuConfResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ImuConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.imu_mode != 0 {
      len += 1;
    }
    if self.imu_sr != 0 {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if self.data_type != 0 {
      len += 1;
    }
    if self.imu_calibration.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.ImuConfig", len)?;
    if self.imu_mode != 0 {
      let v = imu_config::ImuMode::try_from(self.imu_mode)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.imu_mode)))?;
      struct_ser.serialize_field("imuMode", &v)?;
    }
    if self.imu_sr != 0 {
      let v = ImuSampleRate::try_from(self.imu_sr)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.imu_sr)))?;
      struct_ser.serialize_field("imuSr", &v)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if self.data_type != 0 {
      let v = UploadDataType::try_from(self.data_type)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.data_type)))?;
      struct_ser.serialize_field("dataType", &v)?;
    }
    if let Some(v) = self.imu_calibration.as_ref() {
      struct_ser.serialize_field("imuCalibration", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ImuConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "imu_mode",
      "imuMode",
      "imu_sr",
      "imuSr",
      "port",
      "data_type",
      "dataType",
      "imu_calibration",
      "imuCalibration",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      ImuMode,
      ImuSr,
      Port,
      DataType,
      ImuCalibration,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "imuMode" | "imu_mode" => Ok(GeneratedField::ImuMode),
              "imuSr" | "imu_sr" => Ok(GeneratedField::ImuSr),
              "port" => Ok(GeneratedField::Port),
              "dataType" | "data_type" => Ok(GeneratedField::DataType),
              "imuCalibration" | "imu_calibration" => Ok(GeneratedField::ImuCalibration),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ImuConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.ImuConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ImuConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut imu_mode__ = None;
        let mut imu_sr__ = None;
        let mut port__ = None;
        let mut data_type__ = None;
        let mut imu_calibration__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::ImuMode => {
              if imu_mode__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuMode"));
              }
              imu_mode__ = Some(map_.next_value::<imu_config::ImuMode>()? as i32);
            }
            GeneratedField::ImuSr => {
              if imu_sr__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuSr"));
              }
              imu_sr__ = Some(map_.next_value::<ImuSampleRate>()? as i32);
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::DataType => {
              if data_type__.is_some() {
                return Err(serde::de::Error::duplicate_field("dataType"));
              }
              data_type__ = Some(map_.next_value::<UploadDataType>()? as i32);
            }
            GeneratedField::ImuCalibration => {
              if imu_calibration__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuCalibration"));
              }
              imu_calibration__ = map_.next_value()?;
            }
          }
        }
        Ok(ImuConfig {
          imu_mode: imu_mode__.unwrap_or_default(),
          imu_sr: imu_sr__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          data_type: data_type__.unwrap_or_default(),
          imu_calibration: imu_calibration__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.ImuConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for imu_config::ImuMode {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::NotSet => "NOT_SET",
      Self::Acc => "ACC",
      Self::Gyro => "GYRO",
      Self::AccGyro => "ACC_GYRO",
      Self::Euler => "EULER",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for imu_config::ImuMode {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["NOT_SET", "ACC", "GYRO", "ACC_GYRO", "EULER"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = imu_config::ImuMode;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NOT_SET" => Ok(imu_config::ImuMode::NotSet),
          "ACC" => Ok(imu_config::ImuMode::Acc),
          "GYRO" => Ok(imu_config::ImuMode::Gyro),
          "ACC_GYRO" => Ok(imu_config::ImuMode::AccGyro),
          "EULER" => Ok(imu_config::ImuMode::Euler),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for ImuData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.seq_num != 0 {
      len += 1;
    }
    if !self.acc_raw_data.is_empty() {
      len += 1;
    }
    if !self.gyro_raw_data.is_empty() {
      len += 1;
    }
    if !self.eular_raw_data.is_empty() {
      len += 1;
    }
    if self.port != 0 {
      len += 1;
    }
    if !self.acc_correction_data.is_empty() {
      len += 1;
    }
    if !self.gyro_correction_data.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.ImuData", len)?;
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if !self.acc_raw_data.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "accRawData",
        pbjson::private::base64::encode(&self.acc_raw_data).as_str(),
      )?;
    }
    if !self.gyro_raw_data.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "gyroRawData",
        pbjson::private::base64::encode(&self.gyro_raw_data).as_str(),
      )?;
    }
    if !self.eular_raw_data.is_empty() {
      struct_ser.serialize_field("eularRawData", &self.eular_raw_data)?;
    }
    if self.port != 0 {
      let v = CtrlBoxPort::try_from(self.port)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.port)))?;
      struct_ser.serialize_field("port", &v)?;
    }
    if !self.acc_correction_data.is_empty() {
      struct_ser.serialize_field("accCorrectionData", &self.acc_correction_data)?;
    }
    if !self.gyro_correction_data.is_empty() {
      struct_ser.serialize_field("gyroCorrectionData", &self.gyro_correction_data)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ImuData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "seq_num",
      "seqNum",
      "acc_raw_data",
      "accRawData",
      "gyro_raw_data",
      "gyroRawData",
      "eular_raw_data",
      "eularRawData",
      "port",
      "acc_correction_data",
      "accCorrectionData",
      "gyro_correction_data",
      "gyroCorrectionData",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SeqNum,
      AccRawData,
      GyroRawData,
      EularRawData,
      Port,
      AccCorrectionData,
      GyroCorrectionData,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "accRawData" | "acc_raw_data" => Ok(GeneratedField::AccRawData),
              "gyroRawData" | "gyro_raw_data" => Ok(GeneratedField::GyroRawData),
              "eularRawData" | "eular_raw_data" => Ok(GeneratedField::EularRawData),
              "port" => Ok(GeneratedField::Port),
              "accCorrectionData" | "acc_correction_data" => Ok(GeneratedField::AccCorrectionData),
              "gyroCorrectionData" | "gyro_correction_data" => {
                Ok(GeneratedField::GyroCorrectionData)
              }
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ImuData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.ImuData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ImuData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut seq_num__ = None;
        let mut acc_raw_data__ = None;
        let mut gyro_raw_data__ = None;
        let mut eular_raw_data__ = None;
        let mut port__ = None;
        let mut acc_correction_data__ = None;
        let mut gyro_correction_data__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::AccRawData => {
              if acc_raw_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accRawData"));
              }
              acc_raw_data__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::GyroRawData => {
              if gyro_raw_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("gyroRawData"));
              }
              gyro_raw_data__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::EularRawData => {
              if eular_raw_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("eularRawData"));
              }
              eular_raw_data__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::NumberDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
            GeneratedField::Port => {
              if port__.is_some() {
                return Err(serde::de::Error::duplicate_field("port"));
              }
              port__ = Some(map_.next_value::<CtrlBoxPort>()? as i32);
            }
            GeneratedField::AccCorrectionData => {
              if acc_correction_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accCorrectionData"));
              }
              acc_correction_data__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::NumberDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
            GeneratedField::GyroCorrectionData => {
              if gyro_correction_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("gyroCorrectionData"));
              }
              gyro_correction_data__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::NumberDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
          }
        }
        Ok(ImuData {
          seq_num: seq_num__.unwrap_or_default(),
          acc_raw_data: acc_raw_data__.unwrap_or_default(),
          gyro_raw_data: gyro_raw_data__.unwrap_or_default(),
          eular_raw_data: eular_raw_data__.unwrap_or_default(),
          port: port__.unwrap_or_default(),
          acc_correction_data: acc_correction_data__.unwrap_or_default(),
          gyro_correction_data: gyro_correction_data__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.ImuData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ImuSampleRate {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ImuSrUnused => "IMU_SR_UNUSED",
      Self::ImuSrOff => "IMU_SR_OFF",
      Self::ImuSr25 => "IMU_SR_25",
      Self::ImuSr50 => "IMU_SR_50",
      Self::ImuSr100 => "IMU_SR_100",
      Self::ImuSr400 => "IMU_SR_400",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ImuSampleRate {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "IMU_SR_UNUSED",
      "IMU_SR_OFF",
      "IMU_SR_25",
      "IMU_SR_50",
      "IMU_SR_100",
      "IMU_SR_400",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ImuSampleRate;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "IMU_SR_UNUSED" => Ok(ImuSampleRate::ImuSrUnused),
          "IMU_SR_OFF" => Ok(ImuSampleRate::ImuSrOff),
          "IMU_SR_25" => Ok(ImuSampleRate::ImuSr25),
          "IMU_SR_50" => Ok(ImuSampleRate::ImuSr50),
          "IMU_SR_100" => Ok(ImuSampleRate::ImuSr100),
          "IMU_SR_400" => Ok(ImuSampleRate::ImuSr400),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for MagCalibration {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.mag_local_field.is_some() {
      len += 1;
    }
    if self.mag_hard_iron_correction.is_some() {
      len += 1;
    }
    if !self.mag_soft_iron_correction.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.MagCalibration", len)?;
    if let Some(v) = self.mag_local_field.as_ref() {
      struct_ser.serialize_field("magLocalField", v)?;
    }
    if let Some(v) = self.mag_hard_iron_correction.as_ref() {
      struct_ser.serialize_field("magHardIronCorrection", v)?;
    }
    if !self.mag_soft_iron_correction.is_empty() {
      struct_ser.serialize_field("magSoftIronCorrection", &self.mag_soft_iron_correction)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for MagCalibration {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "mag_local_field",
      "magLocalField",
      "mag_hard_iron_correction",
      "magHardIronCorrection",
      "mag_soft_iron_correction",
      "magSoftIronCorrection",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MagLocalField,
      MagHardIronCorrection,
      MagSoftIronCorrection,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "magLocalField" | "mag_local_field" => Ok(GeneratedField::MagLocalField),
              "magHardIronCorrection" | "mag_hard_iron_correction" => {
                Ok(GeneratedField::MagHardIronCorrection)
              }
              "magSoftIronCorrection" | "mag_soft_iron_correction" => {
                Ok(GeneratedField::MagSoftIronCorrection)
              }
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = MagCalibration;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.MagCalibration")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<MagCalibration, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut mag_local_field__ = None;
        let mut mag_hard_iron_correction__ = None;
        let mut mag_soft_iron_correction__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MagLocalField => {
              if mag_local_field__.is_some() {
                return Err(serde::de::Error::duplicate_field("magLocalField"));
              }
              mag_local_field__ = map_.next_value()?;
            }
            GeneratedField::MagHardIronCorrection => {
              if mag_hard_iron_correction__.is_some() {
                return Err(serde::de::Error::duplicate_field("magHardIronCorrection"));
              }
              mag_hard_iron_correction__ = map_.next_value()?;
            }
            GeneratedField::MagSoftIronCorrection => {
              if mag_soft_iron_correction__.is_some() {
                return Err(serde::de::Error::duplicate_field("magSoftIronCorrection"));
              }
              mag_soft_iron_correction__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(MagCalibration {
          mag_local_field: mag_local_field__,
          mag_hard_iron_correction: mag_hard_iron_correction__,
          mag_soft_iron_correction: mag_soft_iron_correction__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.MagCalibration", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for MagConfResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.resp_err != 0 {
      len += 1;
    }
    if self.config.is_some() {
      len += 1;
    }
    if self.mag_coefficient != 0. {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.MagConfResp", len)?;
    if self.resp_err != 0 {
      let v = ConfigRespError::try_from(self.resp_err)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.resp_err)))?;
      struct_ser.serialize_field("respErr", &v)?;
    }
    if let Some(v) = self.config.as_ref() {
      struct_ser.serialize_field("config", v)?;
    }
    if self.mag_coefficient != 0. {
      struct_ser.serialize_field("magCoefficient", &self.mag_coefficient)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for MagConfResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["respErr", "config", "mag_coefficient", "magCoefficient"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      RespErr,
      Config,
      MagCoefficient,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "respErr" => Ok(GeneratedField::RespErr),
              "config" => Ok(GeneratedField::Config),
              "magCoefficient" | "mag_coefficient" => Ok(GeneratedField::MagCoefficient),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = MagConfResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.MagConfResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<MagConfResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut resp_err__ = None;
        let mut config__ = None;
        let mut mag_coefficient__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::RespErr => {
              if resp_err__.is_some() {
                return Err(serde::de::Error::duplicate_field("respErr"));
              }
              resp_err__ = Some(map_.next_value::<ConfigRespError>()? as i32);
            }
            GeneratedField::Config => {
              if config__.is_some() {
                return Err(serde::de::Error::duplicate_field("config"));
              }
              config__ = map_.next_value()?;
            }
            GeneratedField::MagCoefficient => {
              if mag_coefficient__.is_some() {
                return Err(serde::de::Error::duplicate_field("magCoefficient"));
              }
              mag_coefficient__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(MagConfResp {
          resp_err: resp_err__.unwrap_or_default(),
          config: config__,
          mag_coefficient: mag_coefficient__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.MagConfResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for MagConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.mag_sr != 0 {
      len += 1;
    }
    if self.data_type != 0 {
      len += 1;
    }
    if self.mag_calibration.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.MagConfig", len)?;
    if self.mag_sr != 0 {
      let v = MagSampleRate::try_from(self.mag_sr)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.mag_sr)))?;
      struct_ser.serialize_field("magSr", &v)?;
    }
    if self.data_type != 0 {
      let v = UploadDataType::try_from(self.data_type)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.data_type)))?;
      struct_ser.serialize_field("dataType", &v)?;
    }
    if let Some(v) = self.mag_calibration.as_ref() {
      struct_ser.serialize_field("magCalibration", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for MagConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "mag_sr",
      "magSr",
      "data_type",
      "dataType",
      "mag_calibration",
      "magCalibration",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MagSr,
      DataType,
      MagCalibration,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "magSr" | "mag_sr" => Ok(GeneratedField::MagSr),
              "dataType" | "data_type" => Ok(GeneratedField::DataType),
              "magCalibration" | "mag_calibration" => Ok(GeneratedField::MagCalibration),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = MagConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.MagConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<MagConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut mag_sr__ = None;
        let mut data_type__ = None;
        let mut mag_calibration__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MagSr => {
              if mag_sr__.is_some() {
                return Err(serde::de::Error::duplicate_field("magSr"));
              }
              mag_sr__ = Some(map_.next_value::<MagSampleRate>()? as i32);
            }
            GeneratedField::DataType => {
              if data_type__.is_some() {
                return Err(serde::de::Error::duplicate_field("dataType"));
              }
              data_type__ = Some(map_.next_value::<UploadDataType>()? as i32);
            }
            GeneratedField::MagCalibration => {
              if mag_calibration__.is_some() {
                return Err(serde::de::Error::duplicate_field("magCalibration"));
              }
              mag_calibration__ = map_.next_value()?;
            }
          }
        }
        Ok(MagConfig {
          mag_sr: mag_sr__.unwrap_or_default(),
          data_type: data_type__.unwrap_or_default(),
          mag_calibration: mag_calibration__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.MagConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for MagData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.seq_num != 0 {
      len += 1;
    }
    if !self.mag_raw_data.is_empty() {
      len += 1;
    }
    if !self.mag_correction_data.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.MagData", len)?;
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if !self.mag_raw_data.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field(
        "magRawData",
        pbjson::private::base64::encode(&self.mag_raw_data).as_str(),
      )?;
    }
    if !self.mag_correction_data.is_empty() {
      struct_ser.serialize_field("magCorrectionData", &self.mag_correction_data)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for MagData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "seq_num",
      "seqNum",
      "mag_raw_data",
      "magRawData",
      "mag_correction_data",
      "magCorrectionData",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SeqNum,
      MagRawData,
      MagCorrectionData,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "magRawData" | "mag_raw_data" => Ok(GeneratedField::MagRawData),
              "magCorrectionData" | "mag_correction_data" => Ok(GeneratedField::MagCorrectionData),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = MagData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.MagData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<MagData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut seq_num__ = None;
        let mut mag_raw_data__ = None;
        let mut mag_correction_data__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MagRawData => {
              if mag_raw_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("magRawData"));
              }
              mag_raw_data__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::MagCorrectionData => {
              if mag_correction_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("magCorrectionData"));
              }
              mag_correction_data__ = Some(
                map_
                  .next_value::<Vec<::pbjson::private::NumberDeserialize<_>>>()?
                  .into_iter()
                  .map(|x| x.0)
                  .collect(),
              );
            }
          }
        }
        Ok(MagData {
          seq_num: seq_num__.unwrap_or_default(),
          mag_raw_data: mag_raw_data__.unwrap_or_default(),
          mag_correction_data: mag_correction_data__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.MagData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for MagSampleRate {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::MagSrUnused => "MAG_SR_UNUSED",
      Self::MagSrOff => "MAG_SR_OFF",
      Self::MagSr10 => "MAG_SR_10",
      Self::MagSr20 => "MAG_SR_20",
      Self::MagSr50 => "MAG_SR_50",
      Self::MagSr100 => "MAG_SR_100",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for MagSampleRate {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "MAG_SR_UNUSED",
      "MAG_SR_OFF",
      "MAG_SR_10",
      "MAG_SR_20",
      "MAG_SR_50",
      "MAG_SR_100",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = MagSampleRate;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "MAG_SR_UNUSED" => Ok(MagSampleRate::MagSrUnused),
          "MAG_SR_OFF" => Ok(MagSampleRate::MagSrOff),
          "MAG_SR_10" => Ok(MagSampleRate::MagSr10),
          "MAG_SR_20" => Ok(MagSampleRate::MagSr20),
          "MAG_SR_50" => Ok(MagSampleRate::MagSr50),
          "MAG_SR_100" => Ok(MagSampleRate::MagSr100),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for OtaData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.offset != 0 {
      len += 1;
    }
    if !self.data.is_empty() {
      len += 1;
    }
    if self.finished {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.OTAData", len)?;
    if self.offset != 0 {
      struct_ser.serialize_field("offset", &self.offset)?;
    }
    if !self.data.is_empty() {
      #[allow(clippy::needless_borrow)]
      #[allow(clippy::needless_borrows_for_generic_args)]
      struct_ser.serialize_field("data", pbjson::private::base64::encode(&self.data).as_str())?;
    }
    if self.finished {
      struct_ser.serialize_field("finished", &self.finished)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for OtaData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["offset", "data", "finished"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Offset,
      Data,
      Finished,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "offset" => Ok(GeneratedField::Offset),
              "data" => Ok(GeneratedField::Data),
              "finished" => Ok(GeneratedField::Finished),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = OtaData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.OTAData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<OtaData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut offset__ = None;
        let mut data__ = None;
        let mut finished__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Offset => {
              if offset__.is_some() {
                return Err(serde::de::Error::duplicate_field("offset"));
              }
              offset__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Data => {
              if data__.is_some() {
                return Err(serde::de::Error::duplicate_field("data"));
              }
              data__ = Some(
                map_
                  .next_value::<::pbjson::private::BytesDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Finished => {
              if finished__.is_some() {
                return Err(serde::de::Error::duplicate_field("finished"));
              }
              finished__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(OtaData {
          offset: offset__.unwrap_or_default(),
          data: data__.unwrap_or_default(),
          finished: finished__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.OTAData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for OtaConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.cmd != 0 {
      len += 1;
    }
    if self.ota_data.is_some() {
      len += 1;
    }
    if self.file_size != 0 {
      len += 1;
    }
    if !self.file_md5.is_empty() {
      len += 1;
    }
    if !self.file_sha256.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.OtaConfig", len)?;
    if self.cmd != 0 {
      let v = ota_config::Cmd::try_from(self.cmd)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.cmd)))?;
      struct_ser.serialize_field("cmd", &v)?;
    }
    if let Some(v) = self.ota_data.as_ref() {
      struct_ser.serialize_field("otaData", v)?;
    }
    if self.file_size != 0 {
      struct_ser.serialize_field("fileSize", &self.file_size)?;
    }
    if !self.file_md5.is_empty() {
      struct_ser.serialize_field("fileMd5", &self.file_md5)?;
    }
    if !self.file_sha256.is_empty() {
      struct_ser.serialize_field("fileSha256", &self.file_sha256)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for OtaConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "cmd",
      "ota_data",
      "otaData",
      "file_size",
      "fileSize",
      "file_md5",
      "fileMd5",
      "file_sha256",
      "fileSha256",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Cmd,
      OtaData,
      FileSize,
      FileMd5,
      FileSha256,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "cmd" => Ok(GeneratedField::Cmd),
              "otaData" | "ota_data" => Ok(GeneratedField::OtaData),
              "fileSize" | "file_size" => Ok(GeneratedField::FileSize),
              "fileMd5" | "file_md5" => Ok(GeneratedField::FileMd5),
              "fileSha256" | "file_sha256" => Ok(GeneratedField::FileSha256),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = OtaConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.OtaConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<OtaConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut cmd__ = None;
        let mut ota_data__ = None;
        let mut file_size__ = None;
        let mut file_md5__ = None;
        let mut file_sha256__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Cmd => {
              if cmd__.is_some() {
                return Err(serde::de::Error::duplicate_field("cmd"));
              }
              cmd__ = Some(map_.next_value::<ota_config::Cmd>()? as i32);
            }
            GeneratedField::OtaData => {
              if ota_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaData"));
              }
              ota_data__ = map_.next_value()?;
            }
            GeneratedField::FileSize => {
              if file_size__.is_some() {
                return Err(serde::de::Error::duplicate_field("fileSize"));
              }
              file_size__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::FileMd5 => {
              if file_md5__.is_some() {
                return Err(serde::de::Error::duplicate_field("fileMd5"));
              }
              file_md5__ = Some(map_.next_value()?);
            }
            GeneratedField::FileSha256 => {
              if file_sha256__.is_some() {
                return Err(serde::de::Error::duplicate_field("fileSha256"));
              }
              file_sha256__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(OtaConfig {
          cmd: cmd__.unwrap_or_default(),
          ota_data: ota_data__,
          file_size: file_size__.unwrap_or_default(),
          file_md5: file_md5__.unwrap_or_default(),
          file_sha256: file_sha256__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.OtaConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ota_config::Cmd {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "NONE",
      Self::OtaStart => "OTA_START",
      Self::OtaReboot => "OTA_REBOOT",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ota_config::Cmd {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["NONE", "OTA_START", "OTA_REBOOT"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ota_config::Cmd;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NONE" => Ok(ota_config::Cmd::None),
          "OTA_START" => Ok(ota_config::Cmd::OtaStart),
          "OTA_REBOOT" => Ok(ota_config::Cmd::OtaReboot),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for OtaConfigResp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.state != 0 {
      len += 1;
    }
    if self.offset != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.OtaConfigResp", len)?;
    if self.state != 0 {
      let v = ota_config_resp::State::try_from(self.state)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.state)))?;
      struct_ser.serialize_field("state", &v)?;
    }
    if self.offset != 0 {
      struct_ser.serialize_field("offset", &self.offset)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for OtaConfigResp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["state", "offset"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      State,
      Offset,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "state" => Ok(GeneratedField::State),
              "offset" => Ok(GeneratedField::Offset),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = OtaConfigResp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.OtaConfigResp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<OtaConfigResp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut state__ = None;
        let mut offset__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::State => {
              if state__.is_some() {
                return Err(serde::de::Error::duplicate_field("state"));
              }
              state__ = Some(map_.next_value::<ota_config_resp::State>()? as i32);
            }
            GeneratedField::Offset => {
              if offset__.is_some() {
                return Err(serde::de::Error::duplicate_field("offset"));
              }
              offset__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(OtaConfigResp {
          state: state__.unwrap_or_default(),
          offset: offset__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.OtaConfigResp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ota_config_resp::State {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "NONE",
      Self::Downloading => "DOWNLOADING",
      Self::DownloadFinished => "DOWNLOAD_FINISHED",
      Self::Rebooting => "REBOOTING",
      Self::Rebooted => "REBOOTED",
      Self::Abort => "ABORT",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ota_config_resp::State {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "NONE",
      "DOWNLOADING",
      "DOWNLOAD_FINISHED",
      "REBOOTING",
      "REBOOTED",
      "ABORT",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ota_config_resp::State;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "NONE" => Ok(ota_config_resp::State::None),
          "DOWNLOADING" => Ok(ota_config_resp::State::Downloading),
          "DOWNLOAD_FINISHED" => Ok(ota_config_resp::State::DownloadFinished),
          "REBOOTING" => Ok(ota_config_resp::State::Rebooting),
          "REBOOTED" => Ok(ota_config_resp::State::Rebooted),
          "ABORT" => Ok(ota_config_resp::State::Abort),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PortStat {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.port_connected_bits != 0 {
      len += 1;
    }
    if !self.box_sensor_list.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PortStat", len)?;
    if self.port_connected_bits != 0 {
      struct_ser.serialize_field("portConnectedBits", &self.port_connected_bits)?;
    }
    if !self.box_sensor_list.is_empty() {
      let v = self
        .box_sensor_list
        .iter()
        .cloned()
        .map(|v| {
          BoxSensorType::try_from(v)
            .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", v)))
        })
        .collect::<std::result::Result<Vec<_>, _>>()?;
      struct_ser.serialize_field("boxSensorList", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for PortStat {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "port_connected_bits",
      "portConnectedBits",
      "box_sensor_list",
      "boxSensorList",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      PortConnectedBits,
      BoxSensorList,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "portConnectedBits" | "port_connected_bits" => Ok(GeneratedField::PortConnectedBits),
              "boxSensorList" | "box_sensor_list" => Ok(GeneratedField::BoxSensorList),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PortStat;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PortStat")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<PortStat, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut port_connected_bits__ = None;
        let mut box_sensor_list__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::PortConnectedBits => {
              if port_connected_bits__.is_some() {
                return Err(serde::de::Error::duplicate_field("portConnectedBits"));
              }
              port_connected_bits__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::BoxSensorList => {
              if box_sensor_list__.is_some() {
                return Err(serde::de::Error::duplicate_field("boxSensorList"));
              }
              box_sensor_list__ = Some(
                map_
                  .next_value::<Vec<BoxSensorType>>()?
                  .into_iter()
                  .map(|x| x as i32)
                  .collect(),
              );
            }
          }
        }
        Ok(PortStat {
          port_connected_bits: port_connected_bits__.unwrap_or_default(),
          box_sensor_list: box_sensor_list__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.PortStat", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for PpgActivity {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::PpgActRest => "PPG_ACT_REST",
      Self::PpgActOther => "PPG_ACT_OTHER",
      Self::PpgActWalk => "PPG_ACT_WALK",
      Self::PpgActRun => "PPG_ACT_RUN",
      Self::PpgActBike => "PPG_ACT_BIKE",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgActivity {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "PPG_ACT_REST",
      "PPG_ACT_OTHER",
      "PPG_ACT_WALK",
      "PPG_ACT_RUN",
      "PPG_ACT_BIKE",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgActivity;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PPG_ACT_REST" => Ok(PpgActivity::PpgActRest),
          "PPG_ACT_OTHER" => Ok(PpgActivity::PpgActOther),
          "PPG_ACT_WALK" => Ok(PpgActivity::PpgActWalk),
          "PPG_ACT_RUN" => Ok(PpgActivity::PpgActRun),
          "PPG_ACT_BIKE" => Ok(PpgActivity::PpgActBike),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgChip {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::PpgMax32664 => "PPG_MAX32664",
      Self::PpgGh3011 => "PPG_GH3011",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgChip {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["PPG_MAX32664", "PPG_GH3011"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgChip;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PPG_MAX32664" => Ok(PpgChip::PpgMax32664),
          "PPG_GH3011" => Ok(PpgChip::PpgGh3011),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgConfig {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.ppg_mode != 0 {
      len += 1;
    }
    if self.ppg_ur != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgConfig", len)?;
    if self.ppg_mode != 0 {
      let v = PpgMode::try_from(self.ppg_mode)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.ppg_mode)))?;
      struct_ser.serialize_field("ppgMode", &v)?;
    }
    if self.ppg_ur != 0 {
      let v = PpgUr::try_from(self.ppg_ur)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.ppg_ur)))?;
      struct_ser.serialize_field("ppgUr", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for PpgConfig {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["ppg_mode", "ppgMode", "ppg_ur", "ppgUr"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      PpgMode,
      PpgUr,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "ppgMode" | "ppg_mode" => Ok(GeneratedField::PpgMode),
              "ppgUr" | "ppg_ur" => Ok(GeneratedField::PpgUr),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgConfig;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgConfig")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<PpgConfig, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut ppg_mode__ = None;
        let mut ppg_ur__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::PpgMode => {
              if ppg_mode__.is_some() {
                return Err(serde::de::Error::duplicate_field("ppgMode"));
              }
              ppg_mode__ = Some(map_.next_value::<PpgMode>()? as i32);
            }
            GeneratedField::PpgUr => {
              if ppg_ur__.is_some() {
                return Err(serde::de::Error::duplicate_field("ppgUr"));
              }
              ppg_ur__ = Some(map_.next_value::<PpgUr>()? as i32);
            }
          }
        }
        Ok(PpgConfig {
          ppg_mode: ppg_mode__.unwrap_or_default(),
          ppg_ur: ppg_ur__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.PpgConfig", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for PpgData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.seq_num != 0 {
      len += 1;
    }
    if self.report_rate != 0 {
      len += 1;
    }
    if self.mode != 0 {
      len += 1;
    }
    if self.report.is_some() {
      len += 1;
    }
    if self.seg_finished {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgData", len)?;
    if self.seq_num != 0 {
      struct_ser.serialize_field("seqNum", &self.seq_num)?;
    }
    if self.report_rate != 0 {
      let v = PpgUr::try_from(self.report_rate)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.report_rate)))?;
      struct_ser.serialize_field("reportRate", &v)?;
    }
    if self.mode != 0 {
      let v = PpgMode::try_from(self.mode)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.mode)))?;
      struct_ser.serialize_field("mode", &v)?;
    }
    if let Some(v) = self.report.as_ref() {
      struct_ser.serialize_field("report", v)?;
    }
    if self.seg_finished {
      struct_ser.serialize_field("segFinished", &self.seg_finished)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for PpgData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "seq_num",
      "seqNum",
      "report_rate",
      "reportRate",
      "mode",
      "report",
      "seg_finished",
      "segFinished",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      SeqNum,
      ReportRate,
      Mode,
      Report,
      SegFinished,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "seqNum" | "seq_num" => Ok(GeneratedField::SeqNum),
              "reportRate" | "report_rate" => Ok(GeneratedField::ReportRate),
              "mode" => Ok(GeneratedField::Mode),
              "report" => Ok(GeneratedField::Report),
              "segFinished" | "seg_finished" => Ok(GeneratedField::SegFinished),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<PpgData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut seq_num__ = None;
        let mut report_rate__ = None;
        let mut mode__ = None;
        let mut report__ = None;
        let mut seg_finished__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::SeqNum => {
              if seq_num__.is_some() {
                return Err(serde::de::Error::duplicate_field("seqNum"));
              }
              seq_num__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::ReportRate => {
              if report_rate__.is_some() {
                return Err(serde::de::Error::duplicate_field("reportRate"));
              }
              report_rate__ = Some(map_.next_value::<PpgUr>()? as i32);
            }
            GeneratedField::Mode => {
              if mode__.is_some() {
                return Err(serde::de::Error::duplicate_field("mode"));
              }
              mode__ = Some(map_.next_value::<PpgMode>()? as i32);
            }
            GeneratedField::Report => {
              if report__.is_some() {
                return Err(serde::de::Error::duplicate_field("report"));
              }
              report__ = map_.next_value()?;
            }
            GeneratedField::SegFinished => {
              if seg_finished__.is_some() {
                return Err(serde::de::Error::duplicate_field("segFinished"));
              }
              seg_finished__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(PpgData {
          seq_num: seq_num__.unwrap_or_default(),
          report_rate: report_rate__.unwrap_or_default(),
          mode: mode__.unwrap_or_default(),
          report: report__,
          seg_finished: seg_finished__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.PpgData", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for PpgInfo {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.dev_err != 0 {
      len += 1;
    }
    if self.chip != 0 {
      len += 1;
    }
    if !self.version.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgInfo", len)?;
    if self.dev_err != 0 {
      let v = ppg_info::DeviceError::try_from(self.dev_err)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.dev_err)))?;
      struct_ser.serialize_field("devErr", &v)?;
    }
    if self.chip != 0 {
      let v = PpgChip::try_from(self.chip)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.chip)))?;
      struct_ser.serialize_field("chip", &v)?;
    }
    if !self.version.is_empty() {
      struct_ser.serialize_field("version", &self.version)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for PpgInfo {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["devErr", "chip", "version"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      DevErr,
      Chip,
      Version,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "devErr" => Ok(GeneratedField::DevErr),
              "chip" => Ok(GeneratedField::Chip),
              "version" => Ok(GeneratedField::Version),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgInfo;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgInfo")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<PpgInfo, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut dev_err__ = None;
        let mut chip__ = None;
        let mut version__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::DevErr => {
              if dev_err__.is_some() {
                return Err(serde::de::Error::duplicate_field("devErr"));
              }
              dev_err__ = Some(map_.next_value::<ppg_info::DeviceError>()? as i32);
            }
            GeneratedField::Chip => {
              if chip__.is_some() {
                return Err(serde::de::Error::duplicate_field("chip"));
              }
              chip__ = Some(map_.next_value::<PpgChip>()? as i32);
            }
            GeneratedField::Version => {
              if version__.is_some() {
                return Err(serde::de::Error::duplicate_field("version"));
              }
              version__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(PpgInfo {
          dev_err: dev_err__.unwrap_or_default(),
          chip: chip__.unwrap_or_default(),
          version: version__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.PpgInfo", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ppg_info::DeviceError {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ErrNone => "ERR_NONE",
      Self::ErrHard => "ERR_HARD",
      Self::ErrUnknown => "ERR_UNKNOWN",
      Self::ErrParam => "ERR_PARAM",
      Self::ErrTimeout => "ERR_TIMEOUT",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for ppg_info::DeviceError {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "ERR_NONE",
      "ERR_HARD",
      "ERR_UNKNOWN",
      "ERR_PARAM",
      "ERR_TIMEOUT",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ppg_info::DeviceError;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "ERR_NONE" => Ok(ppg_info::DeviceError::ErrNone),
          "ERR_HARD" => Ok(ppg_info::DeviceError::ErrHard),
          "ERR_UNKNOWN" => Ok(ppg_info::DeviceError::ErrUnknown),
          "ERR_PARAM" => Ok(ppg_info::DeviceError::ErrParam),
          "ERR_TIMEOUT" => Ok(ppg_info::DeviceError::ErrTimeout),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgMode {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::Invalid => "PPG_MODE_INVALID",
      Self::Raw => "PPG_MODE_RAW",
      Self::Algo => "PPG_MODE_ALGO",
      Self::Spo2 => "PPG_MODE_SPO2",
      Self::Hr => "PPG_MODE_HR",
      Self::Hrv => "PPG_MODE_HRV",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgMode {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "PPG_MODE_INVALID",
      "PPG_MODE_RAW",
      "PPG_MODE_ALGO",
      "PPG_MODE_SPO2",
      "PPG_MODE_HR",
      "PPG_MODE_HRV",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgMode;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PPG_MODE_INVALID" => Ok(PpgMode::Invalid),
          "PPG_MODE_RAW" => Ok(PpgMode::Raw),
          "PPG_MODE_ALGO" => Ok(PpgMode::Algo),
          "PPG_MODE_SPO2" => Ok(PpgMode::Spo2),
          "PPG_MODE_HR" => Ok(PpgMode::Hr),
          "PPG_MODE_HRV" => Ok(PpgMode::Hrv),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgOpMode {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::OpModeContHrmContSpo2 => "OP_MODE_CONT_HRM_CONT_SPO2",
      Self::OpModeContHrmOnesSpo2 => "OP_MODE_CONT_HRM_ONES_SPO2",
      Self::OpModeContHrm => "OP_MODE_CONT_HRM",
      Self::OpModeSampHrm => "OP_MODE_SAMP_HRM",
      Self::OpModeSampHrmOnesSpo2 => "OP_MODE_SAMP_HRM_ONES_SPO2",
      Self::OpModeActivityTracking => "OP_MODE_ACTIVITY_TRACKING",
      Self::OpModeSpo2Calibration => "OP_MODE_SPO2_CALIBRATION",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgOpMode {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "OP_MODE_CONT_HRM_CONT_SPO2",
      "OP_MODE_CONT_HRM_ONES_SPO2",
      "OP_MODE_CONT_HRM",
      "OP_MODE_SAMP_HRM",
      "OP_MODE_SAMP_HRM_ONES_SPO2",
      "OP_MODE_ACTIVITY_TRACKING",
      "OP_MODE_SPO2_CALIBRATION",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgOpMode;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "OP_MODE_CONT_HRM_CONT_SPO2" => Ok(PpgOpMode::OpModeContHrmContSpo2),
          "OP_MODE_CONT_HRM_ONES_SPO2" => Ok(PpgOpMode::OpModeContHrmOnesSpo2),
          "OP_MODE_CONT_HRM" => Ok(PpgOpMode::OpModeContHrm),
          "OP_MODE_SAMP_HRM" => Ok(PpgOpMode::OpModeSampHrm),
          "OP_MODE_SAMP_HRM_ONES_SPO2" => Ok(PpgOpMode::OpModeSampHrmOnesSpo2),
          "OP_MODE_ACTIVITY_TRACKING" => Ok(PpgOpMode::OpModeActivityTracking),
          "OP_MODE_SPO2_CALIBRATION" => Ok(PpgOpMode::OpModeSpo2Calibration),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgReport {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if !self.raw.is_empty() {
      len += 1;
    }
    if !self.algo.is_empty() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgReport", len)?;
    if !self.raw.is_empty() {
      struct_ser.serialize_field("raw", &self.raw)?;
    }
    if !self.algo.is_empty() {
      struct_ser.serialize_field("algo", &self.algo)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for PpgReport {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["raw", "algo"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Raw,
      Algo,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "raw" => Ok(GeneratedField::Raw),
              "algo" => Ok(GeneratedField::Algo),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgReport;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgReport")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<PpgReport, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut raw__ = None;
        let mut algo__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Raw => {
              if raw__.is_some() {
                return Err(serde::de::Error::duplicate_field("raw"));
              }
              raw__ = Some(map_.next_value()?);
            }
            GeneratedField::Algo => {
              if algo__.is_some() {
                return Err(serde::de::Error::duplicate_field("algo"));
              }
              algo__ = Some(map_.next_value()?);
            }
          }
        }
        Ok(PpgReport {
          raw: raw__.unwrap_or_default(),
          algo: algo__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.PpgReport", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for ppg_report::AlgoData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.op_mode != 0 {
      len += 1;
    }
    if self.hr != 0 {
      len += 1;
    }
    if self.hr_conf != 0 {
      len += 1;
    }
    if self.rr != 0 {
      len += 1;
    }
    if self.rr_conf != 0 {
      len += 1;
    }
    if self.activity != 0 {
      len += 1;
    }
    if self.r != 0 {
      len += 1;
    }
    if self.spo2_conf != 0 {
      len += 1;
    }
    if self.spo2 != 0 {
      len += 1;
    }
    if self.spo2_progress != 0 {
      len += 1;
    }
    if self.spo2_lsq_flag {
      len += 1;
    }
    if self.spo2_mt_flag {
      len += 1;
    }
    if self.spo2_lp_flag {
      len += 1;
    }
    if self.spo2_ur_flag {
      len += 1;
    }
    if self.spo2_state != 0 {
      len += 1;
    }
    if self.scd_state != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgReport.AlgoData", len)?;
    if self.op_mode != 0 {
      let v = PpgOpMode::try_from(self.op_mode)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.op_mode)))?;
      struct_ser.serialize_field("opMode", &v)?;
    }
    if self.hr != 0 {
      struct_ser.serialize_field("hr", &self.hr)?;
    }
    if self.hr_conf != 0 {
      struct_ser.serialize_field("hrConf", &self.hr_conf)?;
    }
    if self.rr != 0 {
      struct_ser.serialize_field("rr", &self.rr)?;
    }
    if self.rr_conf != 0 {
      struct_ser.serialize_field("rrConf", &self.rr_conf)?;
    }
    if self.activity != 0 {
      let v = PpgActivity::try_from(self.activity)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.activity)))?;
      struct_ser.serialize_field("activity", &v)?;
    }
    if self.r != 0 {
      struct_ser.serialize_field("r", &self.r)?;
    }
    if self.spo2_conf != 0 {
      struct_ser.serialize_field("spo2Conf", &self.spo2_conf)?;
    }
    if self.spo2 != 0 {
      struct_ser.serialize_field("spo2", &self.spo2)?;
    }
    if self.spo2_progress != 0 {
      struct_ser.serialize_field("spo2Progress", &self.spo2_progress)?;
    }
    if self.spo2_lsq_flag {
      struct_ser.serialize_field("spo2LsqFlag", &self.spo2_lsq_flag)?;
    }
    if self.spo2_mt_flag {
      struct_ser.serialize_field("spo2MtFlag", &self.spo2_mt_flag)?;
    }
    if self.spo2_lp_flag {
      struct_ser.serialize_field("spo2LpFlag", &self.spo2_lp_flag)?;
    }
    if self.spo2_ur_flag {
      struct_ser.serialize_field("spo2UrFlag", &self.spo2_ur_flag)?;
    }
    if self.spo2_state != 0 {
      let v = PpgSpo2State::try_from(self.spo2_state)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.spo2_state)))?;
      struct_ser.serialize_field("spo2State", &v)?;
    }
    if self.scd_state != 0 {
      let v = PpgScdState::try_from(self.scd_state)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.scd_state)))?;
      struct_ser.serialize_field("scdState", &v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ppg_report::AlgoData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "op_mode",
      "opMode",
      "hr",
      "hr_conf",
      "hrConf",
      "rr",
      "rr_conf",
      "rrConf",
      "activity",
      "r",
      "spo2_conf",
      "spo2Conf",
      "spo2",
      "spo2_progress",
      "spo2Progress",
      "spo2_lsq_flag",
      "spo2LsqFlag",
      "spo2_mt_flag",
      "spo2MtFlag",
      "spo2_lp_flag",
      "spo2LpFlag",
      "spo2_ur_flag",
      "spo2UrFlag",
      "spo2_state",
      "spo2State",
      "scd_state",
      "scdState",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      OpMode,
      Hr,
      HrConf,
      Rr,
      RrConf,
      Activity,
      R,
      Spo2Conf,
      Spo2,
      Spo2Progress,
      Spo2LsqFlag,
      Spo2MtFlag,
      Spo2LpFlag,
      Spo2UrFlag,
      Spo2State,
      ScdState,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "opMode" | "op_mode" => Ok(GeneratedField::OpMode),
              "hr" => Ok(GeneratedField::Hr),
              "hrConf" | "hr_conf" => Ok(GeneratedField::HrConf),
              "rr" => Ok(GeneratedField::Rr),
              "rrConf" | "rr_conf" => Ok(GeneratedField::RrConf),
              "activity" => Ok(GeneratedField::Activity),
              "r" => Ok(GeneratedField::R),
              "spo2Conf" | "spo2_conf" => Ok(GeneratedField::Spo2Conf),
              "spo2" => Ok(GeneratedField::Spo2),
              "spo2Progress" | "spo2_progress" => Ok(GeneratedField::Spo2Progress),
              "spo2LsqFlag" | "spo2_lsq_flag" => Ok(GeneratedField::Spo2LsqFlag),
              "spo2MtFlag" | "spo2_mt_flag" => Ok(GeneratedField::Spo2MtFlag),
              "spo2LpFlag" | "spo2_lp_flag" => Ok(GeneratedField::Spo2LpFlag),
              "spo2UrFlag" | "spo2_ur_flag" => Ok(GeneratedField::Spo2UrFlag),
              "spo2State" | "spo2_state" => Ok(GeneratedField::Spo2State),
              "scdState" | "scd_state" => Ok(GeneratedField::ScdState),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ppg_report::AlgoData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgReport.AlgoData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ppg_report::AlgoData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut op_mode__ = None;
        let mut hr__ = None;
        let mut hr_conf__ = None;
        let mut rr__ = None;
        let mut rr_conf__ = None;
        let mut activity__ = None;
        let mut r__ = None;
        let mut spo2_conf__ = None;
        let mut spo2__ = None;
        let mut spo2_progress__ = None;
        let mut spo2_lsq_flag__ = None;
        let mut spo2_mt_flag__ = None;
        let mut spo2_lp_flag__ = None;
        let mut spo2_ur_flag__ = None;
        let mut spo2_state__ = None;
        let mut scd_state__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::OpMode => {
              if op_mode__.is_some() {
                return Err(serde::de::Error::duplicate_field("opMode"));
              }
              op_mode__ = Some(map_.next_value::<PpgOpMode>()? as i32);
            }
            GeneratedField::Hr => {
              if hr__.is_some() {
                return Err(serde::de::Error::duplicate_field("hr"));
              }
              hr__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::HrConf => {
              if hr_conf__.is_some() {
                return Err(serde::de::Error::duplicate_field("hrConf"));
              }
              hr_conf__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Rr => {
              if rr__.is_some() {
                return Err(serde::de::Error::duplicate_field("rr"));
              }
              rr__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::RrConf => {
              if rr_conf__.is_some() {
                return Err(serde::de::Error::duplicate_field("rrConf"));
              }
              rr_conf__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Activity => {
              if activity__.is_some() {
                return Err(serde::de::Error::duplicate_field("activity"));
              }
              activity__ = Some(map_.next_value::<PpgActivity>()? as i32);
            }
            GeneratedField::R => {
              if r__.is_some() {
                return Err(serde::de::Error::duplicate_field("r"));
              }
              r__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Spo2Conf => {
              if spo2_conf__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2Conf"));
              }
              spo2_conf__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Spo2 => {
              if spo2__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2"));
              }
              spo2__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Spo2Progress => {
              if spo2_progress__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2Progress"));
              }
              spo2_progress__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Spo2LsqFlag => {
              if spo2_lsq_flag__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2LsqFlag"));
              }
              spo2_lsq_flag__ = Some(map_.next_value()?);
            }
            GeneratedField::Spo2MtFlag => {
              if spo2_mt_flag__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2MtFlag"));
              }
              spo2_mt_flag__ = Some(map_.next_value()?);
            }
            GeneratedField::Spo2LpFlag => {
              if spo2_lp_flag__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2LpFlag"));
              }
              spo2_lp_flag__ = Some(map_.next_value()?);
            }
            GeneratedField::Spo2UrFlag => {
              if spo2_ur_flag__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2UrFlag"));
              }
              spo2_ur_flag__ = Some(map_.next_value()?);
            }
            GeneratedField::Spo2State => {
              if spo2_state__.is_some() {
                return Err(serde::de::Error::duplicate_field("spo2State"));
              }
              spo2_state__ = Some(map_.next_value::<PpgSpo2State>()? as i32);
            }
            GeneratedField::ScdState => {
              if scd_state__.is_some() {
                return Err(serde::de::Error::duplicate_field("scdState"));
              }
              scd_state__ = Some(map_.next_value::<PpgScdState>()? as i32);
            }
          }
        }
        Ok(ppg_report::AlgoData {
          op_mode: op_mode__.unwrap_or_default(),
          hr: hr__.unwrap_or_default(),
          hr_conf: hr_conf__.unwrap_or_default(),
          rr: rr__.unwrap_or_default(),
          rr_conf: rr_conf__.unwrap_or_default(),
          activity: activity__.unwrap_or_default(),
          r: r__.unwrap_or_default(),
          spo2_conf: spo2_conf__.unwrap_or_default(),
          spo2: spo2__.unwrap_or_default(),
          spo2_progress: spo2_progress__.unwrap_or_default(),
          spo2_lsq_flag: spo2_lsq_flag__.unwrap_or_default(),
          spo2_mt_flag: spo2_mt_flag__.unwrap_or_default(),
          spo2_lp_flag: spo2_lp_flag__.unwrap_or_default(),
          spo2_ur_flag: spo2_ur_flag__.unwrap_or_default(),
          spo2_state: spo2_state__.unwrap_or_default(),
          scd_state: scd_state__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct(
      "tech.brainco.edu.PpgReport.AlgoData",
      FIELDS,
      GeneratedVisitor,
    )
  }
}
impl serde::Serialize for ppg_report::RawData {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.green1 != 0 {
      len += 1;
    }
    if self.green2 != 0 {
      len += 1;
    }
    if self.ir != 0 {
      len += 1;
    }
    if self.red != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.PpgReport.RawData", len)?;
    if self.green1 != 0 {
      struct_ser.serialize_field("green1", &self.green1)?;
    }
    if self.green2 != 0 {
      struct_ser.serialize_field("green2", &self.green2)?;
    }
    if self.ir != 0 {
      struct_ser.serialize_field("ir", &self.ir)?;
    }
    if self.red != 0 {
      struct_ser.serialize_field("red", &self.red)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for ppg_report::RawData {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["green1", "green2", "ir", "red"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      Green1,
      Green2,
      Ir,
      Red,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "green1" => Ok(GeneratedField::Green1),
              "green2" => Ok(GeneratedField::Green2),
              "ir" => Ok(GeneratedField::Ir),
              "red" => Ok(GeneratedField::Red),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = ppg_report::RawData;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.PpgReport.RawData")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<ppg_report::RawData, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut green1__ = None;
        let mut green2__ = None;
        let mut ir__ = None;
        let mut red__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::Green1 => {
              if green1__.is_some() {
                return Err(serde::de::Error::duplicate_field("green1"));
              }
              green1__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Green2 => {
              if green2__.is_some() {
                return Err(serde::de::Error::duplicate_field("green2"));
              }
              green2__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Ir => {
              if ir__.is_some() {
                return Err(serde::de::Error::duplicate_field("ir"));
              }
              ir__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Red => {
              if red__.is_some() {
                return Err(serde::de::Error::duplicate_field("red"));
              }
              red__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(ppg_report::RawData {
          green1: green1__.unwrap_or_default(),
          green2: green2__.unwrap_or_default(),
          ir: ir__.unwrap_or_default(),
          red: red__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct(
      "tech.brainco.edu.PpgReport.RawData",
      FIELDS,
      GeneratedVisitor,
    )
  }
}
impl serde::Serialize for PpgScdState {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::ScdStateUndetected => "SCD_STATE_UNDETECTED",
      Self::ScdStateOffSkin => "SCD_STATE_OFF_SKIN",
      Self::ScdStateOnSomeSubject => "SCD_STATE_ON_SOME_SUBJECT",
      Self::ScdStateOnSkin => "SCD_STATE_ON_SKIN",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgScdState {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "SCD_STATE_UNDETECTED",
      "SCD_STATE_OFF_SKIN",
      "SCD_STATE_ON_SOME_SUBJECT",
      "SCD_STATE_ON_SKIN",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgScdState;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "SCD_STATE_UNDETECTED" => Ok(PpgScdState::ScdStateUndetected),
          "SCD_STATE_OFF_SKIN" => Ok(PpgScdState::ScdStateOffSkin),
          "SCD_STATE_ON_SOME_SUBJECT" => Ok(PpgScdState::ScdStateOnSomeSubject),
          "SCD_STATE_ON_SKIN" => Ok(PpgScdState::ScdStateOnSkin),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgSpo2State {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::Spo2StateLedAdjustment => "SPO2_STATE_LED_ADJUSTMENT",
      Self::Spo2StateComputation => "SPO2_STATE_COMPUTATION",
      Self::Spo2StateRetSuccess => "SPO2_STATE_RET_SUCCESS",
      Self::Spo2StateTimeout => "SPO2_STATE_TIMEOUT",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgSpo2State {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "SPO2_STATE_LED_ADJUSTMENT",
      "SPO2_STATE_COMPUTATION",
      "SPO2_STATE_RET_SUCCESS",
      "SPO2_STATE_TIMEOUT",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgSpo2State;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "SPO2_STATE_LED_ADJUSTMENT" => Ok(PpgSpo2State::Spo2StateLedAdjustment),
          "SPO2_STATE_COMPUTATION" => Ok(PpgSpo2State::Spo2StateComputation),
          "SPO2_STATE_RET_SUCCESS" => Ok(PpgSpo2State::Spo2StateRetSuccess),
          "SPO2_STATE_TIMEOUT" => Ok(PpgSpo2State::Spo2StateTimeout),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for PpgUr {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::PpgInvalid => "PPG_INVALID",
      Self::PpgOff => "PPG_OFF",
      Self::PpgUr1 => "PPG_UR_1",
      Self::PpgUr5 => "PPG_UR_5",
      Self::PpgUr25 => "PPG_UR_25",
      Self::PpgUr50 => "PPG_UR_50",
      Self::PpgUr100 => "PPG_UR_100",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for PpgUr {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "PPG_INVALID",
      "PPG_OFF",
      "PPG_UR_1",
      "PPG_UR_5",
      "PPG_UR_25",
      "PPG_UR_50",
      "PPG_UR_100",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = PpgUr;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "PPG_INVALID" => Ok(PpgUr::PpgInvalid),
          "PPG_OFF" => Ok(PpgUr::PpgOff),
          "PPG_UR_1" => Ok(PpgUr::PpgUr1),
          "PPG_UR_5" => Ok(PpgUr::PpgUr5),
          "PPG_UR_25" => Ok(PpgUr::PpgUr25),
          "PPG_UR_50" => Ok(PpgUr::PpgUr50),
          "PPG_UR_100" => Ok(PpgUr::PpgUr100),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for SamplingRate {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::None => "SAMPLING_RATE_NONE",
      Self::Off => "SAMPLING_RATE_OFF",
      Self::SamplingRate25 => "SAMPLING_RATE_25",
      Self::SamplingRate50 => "SAMPLING_RATE_50",
      Self::SamplingRate100 => "SAMPLING_RATE_100",
      Self::SamplingRate200 => "SAMPLING_RATE_200",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for SamplingRate {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "SAMPLING_RATE_NONE",
      "SAMPLING_RATE_OFF",
      "SAMPLING_RATE_25",
      "SAMPLING_RATE_50",
      "SAMPLING_RATE_100",
      "SAMPLING_RATE_200",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = SamplingRate;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "SAMPLING_RATE_NONE" => Ok(SamplingRate::None),
          "SAMPLING_RATE_OFF" => Ok(SamplingRate::Off),
          "SAMPLING_RATE_25" => Ok(SamplingRate::SamplingRate25),
          "SAMPLING_RATE_50" => Ok(SamplingRate::SamplingRate50),
          "SAMPLING_RATE_100" => Ok(SamplingRate::SamplingRate100),
          "SAMPLING_RATE_200" => Ok(SamplingRate::SamplingRate200),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for SensorApp {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.msg_id != 0 {
      len += 1;
    }
    if self.device_info.is_some() {
      len += 1;
    }
    if self.device_event != 0 {
      len += 1;
    }
    if self.ota_resp.is_some() {
      len += 1;
    }
    if self.ota_data.is_some() {
      len += 1;
    }
    if self.imu_data.is_some() {
      len += 1;
    }
    if self.imu_resp.is_some() {
      len += 1;
    }
    if self.mag_data.is_some() {
      len += 1;
    }
    if self.mag_resp.is_some() {
      len += 1;
    }
    if self.acc_data.is_some() {
      len += 1;
    }
    if self.acc_resp.is_some() {
      len += 1;
    }
    if self.imu_data2.is_some() {
      len += 1;
    }
    if self.afe_data.is_some() {
      len += 1;
    }
    if self.afe_resp.is_some() {
      len += 1;
    }
    if self.flex_data.is_some() {
      len += 1;
    }
    if self.flex_resp.is_some() {
      len += 1;
    }
    if self.ppg_data.is_some() {
      len += 1;
    }
    if self.ppg_info.is_some() {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.SensorApp", len)?;
    if self.msg_id != 0 {
      struct_ser.serialize_field("msgId", &self.msg_id)?;
    }
    if let Some(v) = self.device_info.as_ref() {
      struct_ser.serialize_field("deviceInfo", v)?;
    }
    if self.device_event != 0 {
      let v = DeviceEvent::try_from(self.device_event)
        .map_err(|_| serde::ser::Error::custom(format!("Invalid variant {}", self.device_event)))?;
      struct_ser.serialize_field("deviceEvent", &v)?;
    }
    if let Some(v) = self.ota_resp.as_ref() {
      struct_ser.serialize_field("otaResp", v)?;
    }
    if let Some(v) = self.ota_data.as_ref() {
      struct_ser.serialize_field("otaData", v)?;
    }
    if let Some(v) = self.imu_data.as_ref() {
      struct_ser.serialize_field("imuData", v)?;
    }
    if let Some(v) = self.imu_resp.as_ref() {
      struct_ser.serialize_field("imuResp", v)?;
    }
    if let Some(v) = self.mag_data.as_ref() {
      struct_ser.serialize_field("magData", v)?;
    }
    if let Some(v) = self.mag_resp.as_ref() {
      struct_ser.serialize_field("magResp", v)?;
    }
    if let Some(v) = self.acc_data.as_ref() {
      struct_ser.serialize_field("accData", v)?;
    }
    if let Some(v) = self.acc_resp.as_ref() {
      struct_ser.serialize_field("accResp", v)?;
    }
    if let Some(v) = self.imu_data2.as_ref() {
      struct_ser.serialize_field("imuData2", v)?;
    }
    if let Some(v) = self.afe_data.as_ref() {
      struct_ser.serialize_field("afeData", v)?;
    }
    if let Some(v) = self.afe_resp.as_ref() {
      struct_ser.serialize_field("afeResp", v)?;
    }
    if let Some(v) = self.flex_data.as_ref() {
      struct_ser.serialize_field("flexData", v)?;
    }
    if let Some(v) = self.flex_resp.as_ref() {
      struct_ser.serialize_field("flexResp", v)?;
    }
    if let Some(v) = self.ppg_data.as_ref() {
      struct_ser.serialize_field("ppgData", v)?;
    }
    if let Some(v) = self.ppg_info.as_ref() {
      struct_ser.serialize_field("ppgInfo", v)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for SensorApp {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "msg_id",
      "msgId",
      "device_info",
      "deviceInfo",
      "device_event",
      "deviceEvent",
      "ota_resp",
      "otaResp",
      "ota_data",
      "otaData",
      "imu_data",
      "imuData",
      "imu_resp",
      "imuResp",
      "mag_data",
      "magData",
      "mag_resp",
      "magResp",
      "acc_data",
      "accData",
      "acc_resp",
      "accResp",
      "imu_data2",
      "imuData2",
      "afe_data",
      "afeData",
      "afe_resp",
      "afeResp",
      "flex_data",
      "flexData",
      "flex_resp",
      "flexResp",
      "ppg_data",
      "ppgData",
      "ppg_info",
      "ppgInfo",
    ];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      MsgId,
      DeviceInfo,
      DeviceEvent,
      OtaResp,
      OtaData,
      ImuData,
      ImuResp,
      MagData,
      MagResp,
      AccData,
      AccResp,
      ImuData2,
      AfeData,
      AfeResp,
      FlexData,
      FlexResp,
      PpgData,
      PpgInfo,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "msgId" | "msg_id" => Ok(GeneratedField::MsgId),
              "deviceInfo" | "device_info" => Ok(GeneratedField::DeviceInfo),
              "deviceEvent" | "device_event" => Ok(GeneratedField::DeviceEvent),
              "otaResp" | "ota_resp" => Ok(GeneratedField::OtaResp),
              "otaData" | "ota_data" => Ok(GeneratedField::OtaData),
              "imuData" | "imu_data" => Ok(GeneratedField::ImuData),
              "imuResp" | "imu_resp" => Ok(GeneratedField::ImuResp),
              "magData" | "mag_data" => Ok(GeneratedField::MagData),
              "magResp" | "mag_resp" => Ok(GeneratedField::MagResp),
              "accData" | "acc_data" => Ok(GeneratedField::AccData),
              "accResp" | "acc_resp" => Ok(GeneratedField::AccResp),
              "imuData2" | "imu_data2" => Ok(GeneratedField::ImuData2),
              "afeData" | "afe_data" => Ok(GeneratedField::AfeData),
              "afeResp" | "afe_resp" => Ok(GeneratedField::AfeResp),
              "flexData" | "flex_data" => Ok(GeneratedField::FlexData),
              "flexResp" | "flex_resp" => Ok(GeneratedField::FlexResp),
              "ppgData" | "ppg_data" => Ok(GeneratedField::PpgData),
              "ppgInfo" | "ppg_info" => Ok(GeneratedField::PpgInfo),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = SensorApp;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.SensorApp")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<SensorApp, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut msg_id__ = None;
        let mut device_info__ = None;
        let mut device_event__ = None;
        let mut ota_resp__ = None;
        let mut ota_data__ = None;
        let mut imu_data__ = None;
        let mut imu_resp__ = None;
        let mut mag_data__ = None;
        let mut mag_resp__ = None;
        let mut acc_data__ = None;
        let mut acc_resp__ = None;
        let mut imu_data2__ = None;
        let mut afe_data__ = None;
        let mut afe_resp__ = None;
        let mut flex_data__ = None;
        let mut flex_resp__ = None;
        let mut ppg_data__ = None;
        let mut ppg_info__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::MsgId => {
              if msg_id__.is_some() {
                return Err(serde::de::Error::duplicate_field("msgId"));
              }
              msg_id__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::DeviceInfo => {
              if device_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceInfo"));
              }
              device_info__ = map_.next_value()?;
            }
            GeneratedField::DeviceEvent => {
              if device_event__.is_some() {
                return Err(serde::de::Error::duplicate_field("deviceEvent"));
              }
              device_event__ = Some(map_.next_value::<DeviceEvent>()? as i32);
            }
            GeneratedField::OtaResp => {
              if ota_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaResp"));
              }
              ota_resp__ = map_.next_value()?;
            }
            GeneratedField::OtaData => {
              if ota_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("otaData"));
              }
              ota_data__ = map_.next_value()?;
            }
            GeneratedField::ImuData => {
              if imu_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuData"));
              }
              imu_data__ = map_.next_value()?;
            }
            GeneratedField::ImuResp => {
              if imu_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuResp"));
              }
              imu_resp__ = map_.next_value()?;
            }
            GeneratedField::MagData => {
              if mag_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("magData"));
              }
              mag_data__ = map_.next_value()?;
            }
            GeneratedField::MagResp => {
              if mag_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("magResp"));
              }
              mag_resp__ = map_.next_value()?;
            }
            GeneratedField::AccData => {
              if acc_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("accData"));
              }
              acc_data__ = map_.next_value()?;
            }
            GeneratedField::AccResp => {
              if acc_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("accResp"));
              }
              acc_resp__ = map_.next_value()?;
            }
            GeneratedField::ImuData2 => {
              if imu_data2__.is_some() {
                return Err(serde::de::Error::duplicate_field("imuData2"));
              }
              imu_data2__ = map_.next_value()?;
            }
            GeneratedField::AfeData => {
              if afe_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("afeData"));
              }
              afe_data__ = map_.next_value()?;
            }
            GeneratedField::AfeResp => {
              if afe_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("afeResp"));
              }
              afe_resp__ = map_.next_value()?;
            }
            GeneratedField::FlexData => {
              if flex_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexData"));
              }
              flex_data__ = map_.next_value()?;
            }
            GeneratedField::FlexResp => {
              if flex_resp__.is_some() {
                return Err(serde::de::Error::duplicate_field("flexResp"));
              }
              flex_resp__ = map_.next_value()?;
            }
            GeneratedField::PpgData => {
              if ppg_data__.is_some() {
                return Err(serde::de::Error::duplicate_field("ppgData"));
              }
              ppg_data__ = map_.next_value()?;
            }
            GeneratedField::PpgInfo => {
              if ppg_info__.is_some() {
                return Err(serde::de::Error::duplicate_field("ppgInfo"));
              }
              ppg_info__ = map_.next_value()?;
            }
          }
        }
        Ok(SensorApp {
          msg_id: msg_id__.unwrap_or_default(),
          device_info: device_info__,
          device_event: device_event__.unwrap_or_default(),
          ota_resp: ota_resp__,
          ota_data: ota_data__,
          imu_data: imu_data__,
          imu_resp: imu_resp__,
          mag_data: mag_data__,
          mag_resp: mag_resp__,
          acc_data: acc_data__,
          acc_resp: acc_resp__,
          imu_data2: imu_data2__,
          afe_data: afe_data__,
          afe_resp: afe_resp__,
          flex_data: flex_data__,
          flex_resp: flex_resp__,
          ppg_data: ppg_data__,
          ppg_info: ppg_info__,
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.SensorApp", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for SensorFeatureMask {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::FeatureNone => "FEATURE_NONE",
      Self::FeatureImu => "FEATURE_IMU",
      Self::FeatureMag => "FEATURE_MAG",
      Self::FeaturePpg => "FEATURE_PPG",
      Self::FeatureAcc => "FEATURE_ACC",
      Self::FeatureFlex => "FEATURE_FLEX",
      Self::FeatureAfe => "FEATURE_AFE",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for SensorFeatureMask {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "FEATURE_NONE",
      "FEATURE_IMU",
      "FEATURE_MAG",
      "FEATURE_PPG",
      "FEATURE_ACC",
      "FEATURE_FLEX",
      "FEATURE_AFE",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = SensorFeatureMask;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "FEATURE_NONE" => Ok(SensorFeatureMask::FeatureNone),
          "FEATURE_IMU" => Ok(SensorFeatureMask::FeatureImu),
          "FEATURE_MAG" => Ok(SensorFeatureMask::FeatureMag),
          "FEATURE_PPG" => Ok(SensorFeatureMask::FeaturePpg),
          "FEATURE_ACC" => Ok(SensorFeatureMask::FeatureAcc),
          "FEATURE_FLEX" => Ok(SensorFeatureMask::FeatureFlex),
          "FEATURE_AFE" => Ok(SensorFeatureMask::FeatureAfe),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for SensorType {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::SensorNone => "SENSOR_NONE",
      Self::SensorCtrlBox => "SENSOR_CTRL_BOX",
      Self::SensorEmg => "SENSOR_EMG",
      Self::SensorEeg => "SENSOR_EEG",
      Self::SensorEcg => "SENSOR_ECG",
      Self::SensorPpg => "SENSOR_PPG",
      Self::SensorGlove => "SENSOR_GLOVE",
      Self::SensorArm8ch => "SENSOR_ARM_8CH",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for SensorType {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &[
      "SENSOR_NONE",
      "SENSOR_CTRL_BOX",
      "SENSOR_EMG",
      "SENSOR_EEG",
      "SENSOR_ECG",
      "SENSOR_PPG",
      "SENSOR_GLOVE",
      "SENSOR_ARM_8CH",
    ];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = SensorType;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "SENSOR_NONE" => Ok(SensorType::SensorNone),
          "SENSOR_CTRL_BOX" => Ok(SensorType::SensorCtrlBox),
          "SENSOR_EMG" => Ok(SensorType::SensorEmg),
          "SENSOR_EEG" => Ok(SensorType::SensorEeg),
          "SENSOR_ECG" => Ok(SensorType::SensorEcg),
          "SENSOR_PPG" => Ok(SensorType::SensorPpg),
          "SENSOR_GLOVE" => Ok(SensorType::SensorGlove),
          "SENSOR_ARM_8CH" => Ok(SensorType::SensorArm8ch),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for UploadDataType {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    let variant = match self {
      Self::TypeUnspecified => "TYPE_UNSPECIFIED",
      Self::RawData => "RAW_DATA",
      Self::CalibratedData => "CALIBRATED_DATA",
    };
    serializer.serialize_str(variant)
  }
}
impl<'de> serde::Deserialize<'de> for UploadDataType {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["TYPE_UNSPECIFIED", "RAW_DATA", "CALIBRATED_DATA"];

    struct GeneratedVisitor;

    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = UploadDataType;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(formatter, "expected one of: {:?}", &FIELDS)
      }

      fn visit_i64<E>(self, v: i64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Signed(v), &self))
      }

      fn visit_u64<E>(self, v: u64) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        i32::try_from(v)
          .ok()
          .and_then(|x| x.try_into().ok())
          .ok_or_else(|| serde::de::Error::invalid_value(serde::de::Unexpected::Unsigned(v), &self))
      }

      fn visit_str<E>(self, value: &str) -> std::result::Result<Self::Value, E>
      where
        E: serde::de::Error,
      {
        match value {
          "TYPE_UNSPECIFIED" => Ok(UploadDataType::TypeUnspecified),
          "RAW_DATA" => Ok(UploadDataType::RawData),
          "CALIBRATED_DATA" => Ok(UploadDataType::CalibratedData),
          _ => Err(serde::de::Error::unknown_variant(value, FIELDS)),
        }
      }
    }
    deserializer.deserialize_any(GeneratedVisitor)
  }
}
impl serde::Serialize for UsbInfo {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.usb_pid != 0 {
      len += 1;
    }
    if self.usb_vid != 0 {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.UsbInfo", len)?;
    if self.usb_pid != 0 {
      struct_ser.serialize_field("usbPid", &self.usb_pid)?;
    }
    if self.usb_vid != 0 {
      struct_ser.serialize_field("usbVid", &self.usb_vid)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for UsbInfo {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["usb_pid", "usbPid", "usb_vid", "usbVid"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      UsbPid,
      UsbVid,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "usbPid" | "usb_pid" => Ok(GeneratedField::UsbPid),
              "usbVid" | "usb_vid" => Ok(GeneratedField::UsbVid),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = UsbInfo;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.UsbInfo")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<UsbInfo, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut usb_pid__ = None;
        let mut usb_vid__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::UsbPid => {
              if usb_pid__.is_some() {
                return Err(serde::de::Error::duplicate_field("usbPid"));
              }
              usb_pid__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::UsbVid => {
              if usb_vid__.is_some() {
                return Err(serde::de::Error::duplicate_field("usbVid"));
              }
              usb_vid__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(UsbInfo {
          usb_pid: usb_pid__.unwrap_or_default(),
          usb_vid: usb_vid__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.UsbInfo", FIELDS, GeneratedVisitor)
  }
}
impl serde::Serialize for Xyz {
  #[allow(deprecated)]
  fn serialize<S>(&self, serializer: S) -> std::result::Result<S::Ok, S::Error>
  where
    S: serde::Serializer,
  {
    use serde::ser::SerializeStruct;
    let mut len = 0;
    if self.x != 0. {
      len += 1;
    }
    if self.y != 0. {
      len += 1;
    }
    if self.z != 0. {
      len += 1;
    }
    let mut struct_ser = serializer.serialize_struct("tech.brainco.edu.XYZ", len)?;
    if self.x != 0. {
      struct_ser.serialize_field("x", &self.x)?;
    }
    if self.y != 0. {
      struct_ser.serialize_field("y", &self.y)?;
    }
    if self.z != 0. {
      struct_ser.serialize_field("z", &self.z)?;
    }
    struct_ser.end()
  }
}
impl<'de> serde::Deserialize<'de> for Xyz {
  #[allow(deprecated)]
  fn deserialize<D>(deserializer: D) -> std::result::Result<Self, D::Error>
  where
    D: serde::Deserializer<'de>,
  {
    const FIELDS: &[&str] = &["x", "y", "z"];

    #[allow(clippy::enum_variant_names)]
    enum GeneratedField {
      X,
      Y,
      Z,
    }
    impl<'de> serde::Deserialize<'de> for GeneratedField {
      fn deserialize<D>(deserializer: D) -> std::result::Result<GeneratedField, D::Error>
      where
        D: serde::Deserializer<'de>,
      {
        struct GeneratedVisitor;

        impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
          type Value = GeneratedField;

          fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
            write!(formatter, "expected one of: {:?}", &FIELDS)
          }

          #[allow(unused_variables)]
          fn visit_str<E>(self, value: &str) -> std::result::Result<GeneratedField, E>
          where
            E: serde::de::Error,
          {
            match value {
              "x" => Ok(GeneratedField::X),
              "y" => Ok(GeneratedField::Y),
              "z" => Ok(GeneratedField::Z),
              _ => Err(serde::de::Error::unknown_field(value, FIELDS)),
            }
          }
        }
        deserializer.deserialize_identifier(GeneratedVisitor)
      }
    }
    struct GeneratedVisitor;
    impl<'de> serde::de::Visitor<'de> for GeneratedVisitor {
      type Value = Xyz;

      fn expecting(&self, formatter: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        formatter.write_str("struct tech.brainco.edu.XYZ")
      }

      fn visit_map<V>(self, mut map_: V) -> std::result::Result<Xyz, V::Error>
      where
        V: serde::de::MapAccess<'de>,
      {
        let mut x__ = None;
        let mut y__ = None;
        let mut z__ = None;
        while let Some(k) = map_.next_key()? {
          match k {
            GeneratedField::X => {
              if x__.is_some() {
                return Err(serde::de::Error::duplicate_field("x"));
              }
              x__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Y => {
              if y__.is_some() {
                return Err(serde::de::Error::duplicate_field("y"));
              }
              y__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
            GeneratedField::Z => {
              if z__.is_some() {
                return Err(serde::de::Error::duplicate_field("z"));
              }
              z__ = Some(
                map_
                  .next_value::<::pbjson::private::NumberDeserialize<_>>()?
                  .0,
              );
            }
          }
        }
        Ok(Xyz {
          x: x__.unwrap_or_default(),
          y: y__.unwrap_or_default(),
          z: z__.unwrap_or_default(),
        })
      }
    }
    deserializer.deserialize_struct("tech.brainco.edu.XYZ", FIELDS, GeneratedVisitor)
  }
}
